package de.bsvrz.buv.plugin.anlagendarstellung.figures;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.PointList;
import org.eclipse.draw2d.geometry.Rectangle;

import de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts.ADefs;

/**
 * Figure fr das obere Dreieck des Pickers.
 * 
 * @author Swarco Traffic Systems GmbH
 * 
 */
public class FigurePickerVerticalTriangleTop extends FigurePickerConnectionBase
{
	private FixedAnchorA inAnchor, outAnchor;

	private final Dimension DIM = new Dimension(25, 20);

	public FigurePickerVerticalTriangleTop()
	{
		super();

		this.setSize(DIM);

		inAnchor = new FixedAnchorA(this);
		inAnchor.place = new Point(1, 0);
		targetAnchors.put("in_tri_top", inAnchor);

		outAnchor = new FixedAnchorA(this);
		outAnchor.place = new Point(1, 2);
		sourceAnchors.put("out_tri_top", outAnchor);
	}

	@Override
	protected void paintFigure(Graphics g)
	{
		super.paintFigure(g);

		Rectangle r = bounds;

		int x = r.x;
		int y = r.y;
		int width = r.width;
		int height = r.height;

		PointList pl = new PointList(4);
		pl.addPoint(x + width / 2, y + 0);
		pl.addPoint(x + width, y + height);
		pl.addPoint(x + width / 2, y + height);
		// inAnchor.place = new Point(r.x + r.width / 2, r.y + triangleHeight);
		// outAnchor.place = new Point(r.x + r.width / 2, r.y + triangleHeight);
		inAnchor.place = new Point(x + width / 2, height);
		outAnchor.place = new Point(x + width / 2, height);
		pl.addPoint(x + 0, y + height);
		g.setBackgroundColor(ColorConstants.black);
		g.fillPolygon(pl);

		if (false)
		{
			g.setForegroundColor(ColorConstants.red);
			g.drawPolygon(pl);
		}
	}
	
	

}
