/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.figures;

import java.util.TimerTask;

import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

/**
 * Thread, der den {@link AnzeigeInhaltAuswahlDialog} schliesst.               
 * 
 * @author Pittner
 * 
 */
public class SchliesseZeitGesteuert extends TimerTask
{

  AnzeigeInhaltAuswahlDialog _anzeigeInhaltAuswahlDialog;

  Point _point;

  public SchliesseZeitGesteuert(AnzeigeInhaltAuswahlDialog dialog, Point p)
  {
    super();
    _anzeigeInhaltAuswahlDialog = dialog;
    _point = p;
  }

  @Override
  public void run()
  {
    // TODO Auto-generated method stub
    if (!_anzeigeInhaltAuswahlDialog.getShell().isDisposed())
    {

      Display.getDefault().asyncExec(new Runnable() {
        public void run()
        {
          Point pt = Display.getCurrent().getCursorLocation();

          if (_anzeigeInhaltAuswahlDialog != null)
          {

            Shell shell = _anzeigeInhaltAuswahlDialog.getShell();

            if (shell != null && !shell.isDisposed())
            {
              Rectangle bounds = shell.getBounds();
              if (!bounds.contains(pt))
              {
                if (!_anzeigeInhaltAuswahlDialog.getShell().isDisposed())
                {
                  _anzeigeInhaltAuswahlDialog.getShell().dispose();
                  _anzeigeInhaltAuswahlDialog = null;
                }
              }
            }
          }
        }
      });
    }
  }

}
