package de.bsvrz.buv.plugin.anlagendarstellung.legende;


/**
 * Anzeigendefinition.
 * 
 * @author Pittner
 */
public enum LegendeDefinitionAnzeige {

	/** Helligkeit */
	HELLIGKEIT("Helligkeit", "icons/legende/hell_prozent.png"),

	/** AnzeigeTyp-A */
//	PROGRAMM("Programm-Status", "icons/legende/anzeige_typ_a.png"),
	/** AnzeigeTyp-A */
	ZEITSTEMPEL("Zeitpunkt letzte nderung", "icons/legende/time_stamp.png");


	public static final String BEZEICHNUNG = "Zustand";

  /** Name der Funktionsgruppe. */
	private String name;
	
	/** Farbe der Funktionsgruppe. */
	private String path;

	/**
	 * Privater Konstruktor.
	 * 
	 * @param name
	 *            Name des Zustandes
	 */
	private LegendeDefinitionAnzeige(final String name, String path) {
		this.name = name;
		this.path = path;
	}

	/**
	 * Gibt den Namen der Funktionsgruppe zur&uuml;ck.
	 * 
	 * @return Name des Zustandes
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * Gibt den Namen der Funktionsgruppe zur&uuml;ck.
	 * 
	 * @return Name des Zustandes
	 */
	public String getPfad() {
	  return path;
	}
	
	 public String getBezeichnnung()
	  {
	    // TODO Auto-generated method stub
	    return BEZEICHNUNG;
	  }
	
}
