package de.bsvrz.buv.plugin.anlagendarstellung.sonderprogramm;

import java.text.SimpleDateFormat;
import java.util.Date;

import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.config.SystemObject;

/**
 * Hilfsklasse fr die Baumdarstellung
 * 
 * @author Pittner
 * 
 */
public class Programm
{
  private Object parent = null;

  private String name = null;

  private String stand = null;
  private String standSoll = null;

  private String simulation = null;

  private String benutzer = null;

  private String ursache = null;

  private String veranlasser = null;

  private String zeitpunkt = null;
  
  private boolean aktiv = false;

  public ResultData result = null;
  
  /**
   * Das Format der nderungszeit
   */
  private final static SimpleDateFormat _sdf = new SimpleDateFormat("dd.MM.yyyy HH:mm:ss");

  public Programm(Object parent, ResultData result)
  {
    this.parent = parent;
    this.result = result;

    if (result.hasData())
    {

      Data data = result.getData();

      name = data.getItem("nameAnwender").asTextValue().getValueText();
      String zustand = data.getItem("Zustand").asTextValue().getValueText();
      stand = zustand.equals("undefiniert") ? "Erstellt" : zustand;
      if (stand.equals("Aktiv"))
        aktiv = true;
      standSoll = " - ";
      simulation = data.getItem("vorschau").asTextValue().getValueText();
      SystemObject so = data.getItem("Urlasser").getItem("BenutzerReferenz").asReferenceValue().getSystemObject();
      if (so != null)
        benutzer = so.getName();        
      ursache = data.getItem("Urlasser").getItem("Ursache").asTextValue().getValueText();
      veranlasser = data.getItem("Urlasser").getItem("Veranlasser").asTextValue().getValueText();
      zeitpunkt = _sdf.format(new Date(result.getDataTime()));
    }
  }

  public String getStand()
  {
    return stand;
  }

  public String getSimulation()
  {
    return simulation;
  }

  public String getBenutzer()
  {
    return benutzer;
  }

  public String getUrsache()
  {
    return ursache;
  }

  public String getVeranlasser()
  {
    return veranlasser;
  }

  public String getZeitpunkt()
  {
    return zeitpunkt;
  }

  public String toString()
  {
    return name;
  }

  public Object getParent()
  {
    return parent;
  }

  public ResultData getResult()
  {
    return result;
  }

  
  public void setStand(String stand)
  {
    this.stand = stand;
  }

  public String getStandSoll()
  {
    return standSoll;
  }

  public void setStandSoll(String standSoll)
  {
    this.standSoll = standSoll;
  }

  public boolean isAktiv()
  {
    return aktiv;
  }

  public void setAktiv(boolean aktiv)
  {
    this.aktiv = aktiv;
  }
}