/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.status;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.swt.graphics.Color;

/**
 * Klasse fr alle Elemente, die nicht durch {@link StatusDe} gekapselt werden
 * 
 * @author Pittner
 * 
 */
public class StatusEakSmUzVrz implements Status
{

  private String _status;

  private Color COLOR_OK = ColorConstants.green;

  private Color COLOR_TEILSTOERUNG = new Color(null, 240, 128, 128);

  private Color COLOR_GESTOERT = ColorConstants.red;

  private Color COLOR_KEINE_DATEN = ColorConstants.yellow;

  private Color COLOR_KEINE_QUELLE = ColorConstants.orange;

  public StatusEakSmUzVrz()
  {
    _status = NICHT_DEFINIERT;
  }

  public String getStatus()
  {
    // TODO Auto-generated method stub
    return _status;
  }

  /*
   * (non-Javadoc)
   * 
   * @see de.bsvrz.buv.plugin.anlagendarstellung.status.Status#setStatus(java.lang.String)
   */
  public boolean setStatus(String status)
  {
    // TODO Auto-generated method stub

    if (!(status.equals(OK) || status.equals(TEILSTOERUNG) || status.equals(GESTOERT) || status.equals(KEINE_DATEN)
        || status.equals(KEINE_QUELLE) || status.equals(NICHT_DEFINIERT)))
    {

      return false;

    }

    _status = status;
    return true;
  }

  public Color getColor()
  {
    // TODO Auto-generated method stub
    Color color = null;

    if (_status.equals(OK))
      color = COLOR_OK;
    else if (_status.equals(TEILSTOERUNG))
      color = COLOR_TEILSTOERUNG;
    else if (_status.equals(GESTOERT))
      color = COLOR_GESTOERT;
    else if (_status.equals(KEINE_DATEN))
      color = COLOR_KEINE_DATEN;
    else if (_status.equals(KEINE_QUELLE))
      color = COLOR_KEINE_QUELLE;
    else
      color = COLOR_NICHT_DEFINIERT;

    return color;
  }

}
