/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.parameter.ufd.common;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.runtime.Assert;
import org.eclipse.jface.fieldassist.ControlDecoration;
import org.eclipse.jface.fieldassist.FieldDecorationRegistry;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import de.bsvrz.buv.plugin.parameter.ufd.dav.DaVDataUpdateEvent;
import de.bsvrz.buv.plugin.parameter.ufd.dav.DaVDataUpdateListener;
import de.bsvrz.buv.plugin.parameter.ufd.dav.DaVKommunikation;
import de.bsvrz.buv.plugin.parameter.ufd.dav.IDaVDataUpdateListener;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.DataState;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.koelnloevenich.dif.basislib.urlasserdialog.UrlasserDialog;
import de.koelnloevenich.dif.basislib.urlasserdialog.UrlasserDialog.UrlasserDialogInfo;

/**
 * Abstrakte View implementiert Funktionen zur Bearbeitung von Parametern
 * 
 * @author Sans
 * 
 */
public abstract class AbstractViewParameter extends ViewPart implements IDaVDataUpdateListener
{
  
  /**
   * Fertig angelegte Tabs fr jede ATG
   */
  private int[] _tabCnt = new int[getParameterAtgPids().size()];
  
  private CTabFolder _tabFolder = null;

  private Composite _composite = null;

  private Button buttonAlle;
  
  private Button buttonOk;

  private Button buttonUebernehemen;

  private Button buttonAbbrechen;

  private Button buttonHilfe;

  private IMemento _memento = null;

  private String _secondViewId;

  private ClientDavInterface _connection;

  private Button buttonKopieren;

  private Button buttonEinfuegen;
  
  private Data[] _copyData = new Data[0];
  
  private CTabItem _copyTabItem = null;
  
  private ControlDecoration _copyDecor;
  
  /**
   * Erzeugt die Layouts und die DataContainerComposites fr die behandelten Parameterstze
   * 
   * @param parent Eltern-Composite
   */
  protected abstract void createLayoutAndChildren(Composite parent);
  
  /**
   * 
   * @return die verwalteten Parameter-Attributgruppen
   */
  protected abstract List<String> getParameterAtgPids();
  
  /**
   * 
   * @param atgPid Attributgruppen-Pid
   * @return Die Klasse des DataContainerComposites fr die bergebenen Attributgruppe
   */
  protected abstract Class<? extends AbstractDataContainerComposite> getDataContainerComposite(String atgPid);
  
  protected abstract String getHelpId();
  
  @Override
  public void createPartControl( Composite parent )
  {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessVerticalSpace = true;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.FILL;
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;
    _composite = new Composite( parent, SWT.NONE );
    _composite.setLayout( gridLayout );
    _composite.setLayoutData( gridData );
    
    //Fr die F1 Taste
    PlatformUI.getWorkbench().getHelpSystem().setHelp( _composite, getHelpId() );   
    
    // Darstellung aufbauen
    createCompositeTab();
    createCompositeBottom();

    restoreState();

    _connection = DaVKommunikation.getInstanz().holeDaVVerbindung();

    List<SystemObject> list = new ArrayList<SystemObject>();

    if ( _secondViewId.contains( ";" ) )
    {
      String[] split = _secondViewId.split( ";" );

      for (String s : split)
      {
        SystemObject so = _connection.getDataModel().getObject( s );
        list.add( so );
      }

    }
    else
    {
      SystemObject so = _connection.getDataModel().getObject( _secondViewId );
      list.add( so );
    }

    erzeugeTabItems( list );

    DaVDataUpdateListener.getInstanz().addDaVDataUpdateListener( this );
    
    for (String atgPid: getParameterAtgPids()) {
      DaVKommunikation.getInstanz().anmeldeDaten( list, atgPid, "asp.parameterSoll" );      
    }
  }

  @Override
  public void setFocus()
  {
    //Fr die F1 Taste
    if (_composite != null)
      _composite.setFocus();
  }

  /**
   * This method initializes _tabFolder
   * 
   */
  private void createCompositeTab()
  {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.grabExcessVerticalSpace = true;
    gridData.verticalAlignment = GridData.FILL;

    _tabFolder = new CTabFolder( _composite, SWT.NONE );
    _tabFolder.setLayout( new GridLayout() );
    _tabFolder.setLayoutData( gridData );
//    _tabFolder.addSelectionListener( new SelectionAdapter()
//    {
//      @Override
//      public void widgetSelected( SelectionEvent e )
//      {
//
//        CTabFolder folder = (CTabFolder) e.getSource();
//        CTabItem itemSel = folder.getSelection();
//
//        Composite cSel = (Composite) itemSel.getControl();
//
//        if ( cSel.getChildren() != null && cSel.getChildren().length > 0 )
//        {
//          NSZuBenutzendeEingangsgroessenComposite compParSel = (NSZuBenutzendeEingangsgroessenComposite) cSel.getChildren()[0];
//
//          TableViewer tvParameter[] = new TableViewer[1];
//          for (int i = 0; i < 1; i++)
//          {
//            tvParameter[i] = compParSel.getTvAnzeige();          
//            tvParameter[i].refresh();
//          }
//        }
//
//      }
//    } );
  }

  /**
   * This method initializes _tabItem for the list of system objects
   * 
   * @param list  list of system objects
   */
  public void erzeugeTabItems( List<SystemObject> list )
  {
   
    
    for (SystemObject so : list)
    {
      CTabItem tabItem = new CTabItem( _tabFolder, SWT.NONE );
      tabItem.setText( so.getName() );
      tabItem.setData( so.getName(), so.getPid() );

      Composite composite = new Composite( _tabFolder, SWT.NONE );

      tabItem.setControl( composite );
      
      createLayoutAndChildren(composite);
     }
    _tabFolder.setSelection( 0 );
    
    buttonEinfuegen.setEnabled( false );
    buttonAlle.setEnabled( _tabFolder.getItemCount() > 1 );
    
    
  }
  
  
    
  /**
   * This method initializes _compositeBottom
   * 
   */
  private void createCompositeBottom() {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.verticalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    
    GridLayout gridLayout = new GridLayout(2, false);
    gridLayout.horizontalSpacing = 0;
    gridLayout.verticalSpacing = 0;
    gridLayout.marginHeight = 0;
    gridLayout.marginWidth = 0;
           
    Composite compositeBottom = new Composite( _composite, SWT.NONE );
    compositeBottom.setLayout( gridLayout );
    compositeBottom.setLayoutData( gridData );
        
    createCompositeCopyPaste(compositeBottom);
    createCompositeButton(compositeBottom);
  }
  
  
  /**
   * This method initializes _compositeBottom
   * 
   */
  private void createCompositeButton(Composite parent)
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.END;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.CENTER;
    Composite compositeButton = new Composite( parent, SWT.NONE );
    compositeButton.setLayoutData( gridData );
    compositeButton.setLayout( rowLayout );

    buttonAlle = new Button( compositeButton, SWT.NONE );
    buttonAlle.setText( "Alle setzen" );
    buttonAlle.setToolTipText( "Einstellungen bei allen ausgewhlten gleichartigen Messstellen setzen" );
    buttonAlle.addSelectionListener( new SelectionAdapter()
    {
      @Override
      public void widgetSelected( SelectionEvent e )
      {
        aktionAlle();
      }
    } );
   
    buttonOk = new Button( compositeButton, SWT.NONE );
    buttonOk.setText( "Ok" );
    buttonOk.addSelectionListener( new SelectionAdapter()
    {
      @Override
      public void widgetSelected( SelectionEvent e )
      {
        aktionSchalten();
      }
    } );

    buttonUebernehemen = new Button( compositeButton, SWT.NONE );
    buttonUebernehemen.setText( "bernehmen" );
    buttonUebernehemen.addSelectionListener( new SelectionAdapter()
    {
      @Override
      public void widgetSelected( SelectionEvent e )
      {
        aktionUebernehmen();
      }
    } );

    buttonAbbrechen = new Button( compositeButton, SWT.NONE );
    buttonAbbrechen.setText( "Abbrechen" );
    buttonAbbrechen.addSelectionListener( new SelectionAdapter()
    {

      @Override
      public void widgetSelected( SelectionEvent e )
      {
        dispose();
      }

    } );
    buttonHilfe = new Button( compositeButton, SWT.NONE );
    buttonHilfe.setText( "Hilfe" );
    buttonHilfe.addSelectionListener( new SelectionAdapter()
    {

      @Override
      public void widgetSelected( SelectionEvent e )
      {
        aktionHilfe();
      }

    } );
  }

  private void createCompositeCopyPaste(Composite parent)
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.BEGINNING;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.CENTER;
    Composite compositeCopyPaste = new Composite( parent, SWT.NONE );
    compositeCopyPaste.setLayoutData( gridData );
    compositeCopyPaste.setLayout( rowLayout );

    buttonKopieren = new Button( compositeCopyPaste, SWT.NONE );
    buttonKopieren.setText( "Kopieren" );
    buttonKopieren.setToolTipText( "Kopieren der Einstellungen fr die aktuelle Messstelle" );
    buttonKopieren.addSelectionListener( new SelectionAdapter()
    {
      @Override
      public void widgetSelected( SelectionEvent e )
      {
        aktionKopieren();
      }
    } );
   
    _copyDecor = new ControlDecoration(buttonKopieren, SWT.LEFT | SWT.TOP);
    Image image = FieldDecorationRegistry.getDefault()
          .getFieldDecoration(FieldDecorationRegistry.DEC_INFORMATION)
          .getImage();
    _copyDecor.setImage(image);
//    _tableDecor.setMarginWidth(2);
//    _tableDecor.setShowHover(false);
    _copyDecor.hide();
    // Schaffe Platz fr Decorator Image
    rowLayout.marginLeft = image.getBounds().width - 2;
    
    buttonEinfuegen = new Button( compositeCopyPaste, SWT.NONE );
    buttonEinfuegen.setText( "Einfgen" );
    buttonEinfuegen.setToolTipText( "Einfgen der zuletzt kopierten Einstellungen in die aktuelle Messstelle" );
    buttonEinfuegen.addSelectionListener( new SelectionAdapter()
    {
      @Override
      public void widgetSelected( SelectionEvent e )
      {
        aktionEinfuegen();
      }
    } );
    
  }
  
  /**
   * Zeigt die Hilfe an.
   * 
   */
  protected void aktionHilfe()
  {
    PlatformUI.getWorkbench().getHelpSystem().displayHelp(getHelpId());
  }
  
  protected void aktionAlle()
  {
//    System.out.println("Aktion alle!!!");
    
    // aktueller Reiter
    CTabItem itemSel = _tabFolder.getSelection();
    if ( itemSel == null ) {
      itemSel = _tabFolder.getItems()[0];
    }

    MessageBox mb = new MessageBox( new Shell( Display.getCurrent() ), 
        SWT.ICON_WARNING | SWT.OK | SWT.CANCEL);
    mb.setText( "Alle setzen" );
    mb.setMessage( "Die Einstellungen ALLER Objekte dieser Parameter-Ansicht werden auf die Daten des aktuellen Objekts \""
        + itemSel.getText() + "\" gesetzt"); 
        
    if (mb.open() == SWT.CANCEL) {
      return;
    }
    
    Composite compSel = (Composite) itemSel.getControl();
    
    Control[] source = compSel.getChildren();
    
    CTabItem[] items = _tabFolder.getItems();
    
    for (CTabItem item : items)
    {
//      System.out.println("Item: " + item.getText());
      
      if ( !item.equals( itemSel ) )
      {
        Composite c = (Composite) item.getControl();
        
        Control[] children = c.getChildren();
        
//        System.out.println("Bearbeite Item: " + item.getText() + " Anzahl children: " + children.length);

        for (int i = 0; i < children.length; i++) {
          Data data = ((IDataContainer)source[i]).getUpdate();
          if (data != null) {
//            System.out.println("setUpdate() " + item.getText() + ": " + data);
            ((IDataContainer)children[i]).setUpdate(data);
          }
          else {
            System.out.println("Data ist NULL!");
          }
        }
      }
    }
  }

  protected void aktionSchalten()
  {
    if ( schaltenUndParametrieren() )
    {
      dispose();
    }
//    else
//    {
//      MessageBox mb = new MessageBox( new Shell( Display.getCurrent() ), SWT.ICON_INFORMATION | SWT.OK );
//      mb.setText( "Fehler Urlasser" );
//      mb.setMessage( "Objekt konnte nicht parametriert werden: " + "" );
//      mb.open();
//      return;
//    }

  }

  protected void aktionUebernehmen()
  {
    if ( schaltenUndParametrieren() )
    {
      // keine weiteren Aktionen
    }
//    else
//    {
//      MessageBox mb = new MessageBox( new Shell( Display.getCurrent() ), SWT.ICON_INFORMATION | SWT.OK );
//      mb.setText( "Fehler Urlasser" );
//      mb.setMessage( "Objekt konnte nicht parametriert werden: " + "" );
//      mb.open();
//      return;
//    }

  }
  
  protected void aktionKopieren() {
    
    CTabItem sel = _tabFolder.getSelection();
    if (sel != null) {
      
      Composite composite = (Composite)sel.getControl();
      Control[] control = composite.getChildren();
      
      _copyData = new Data[control.length];
      
      for (int i = 0; i < _copyData.length; i++) {
        _copyData[i] = ((IDataContainer)control[i]).getUpdate();
      }
      
      _copyTabItem = sel;
      
      if (_copyData.length > 0) {
        buttonEinfuegen.setEnabled(true);
        
        String text = "Objekt: " + _copyTabItem.getText();
        if (_copyData.length == 1) {
          text += "\nDatensatz: ";
          if (_copyData[0] != null) {
            text += _copyData[0].getName(); 
          }
          else {
            text += "null";
          }
            
        }
        else {
          text += "\nDatenstze:";
          for (int i = 0; i < _copyData.length; i++) {
            if (_copyData[i] != null) {
              text += "\n\t" + _copyData[i].getName(); 
            }
            else {
              text += "\n\tnull";
            }
          }   
        }
        _copyDecor.setDescriptionText(text);
        _copyDecor.show();
      }
      else {
        buttonEinfuegen.setEnabled(false);
        _copyDecor.hashCode();
        _copyDecor.setDescriptionText("");
      }
      
    }
    
  }
  
  protected void aktionEinfuegen() {
    
    if (_copyTabItem != null) {
          
      CTabItem sel = _tabFolder.getSelection();
      if (sel == null) {
        sel = _tabFolder.getItems()[0];
      }  
      MessageBox mb = new MessageBox( new Shell( Display.getCurrent() ), 
          SWT.ICON_WARNING | SWT.OK | SWT.CANCEL);
      mb.setText( "Daten Einfgen" );
      mb.setMessage( "Die kopierten Daten des Objekts \"" + _copyTabItem.getText() + 
          "\" werden in die Einstellungen des aktuellen Objekts eingefgt");
      if (mb.open() == SWT.OK) {
        Composite composite = (Composite)sel.getControl();
        Control[] control = composite.getChildren();
        
        Assert.isTrue(control.length == _copyData.length);
        
        for (int i = 0; i < control.length; i++) {
          ((IDataContainer)control[i]).setUpdate(_copyData[i]);
        }  
      }
    }
  }

  @Override
  public void init( IViewSite site, IMemento memento ) throws PartInitException
  {
    _memento = memento;
    _secondViewId = site.getSecondaryId();
    super.init( site, memento );
  }

  private void restoreState()
  {
    
    if ( _memento == null )
    {
      return;
    }

    _secondViewId = _memento.getString( getClass().getName() + "#secondViewId" );
  }

  @Override
  public void saveState( IMemento memento )
  {
    memento.putString( getClass().getName() + "#secondViewId", _secondViewId );
 
    super.saveState( memento );
  }

  /**
   * Schalten und Parametrieren im DAV durchfhren
   * 
   * @return Durchfhrung erfolgreich
   */
  private Boolean schaltenUndParametrieren()
  {   
    DataModel dataModel = _connection.getDataModel();

    Aspect asp = dataModel.getAspect( "asp.parameterVorgabe" );
//    AttributeGroup atg = dataModel.getAttributeGroup( _attributGruppe );
 
    List<ResultData> resultDataList = new ArrayList<ResultData>();
    List<IDataContainer> containerList = new ArrayList<IDataContainer>();

    /*
     * Tabs durchlaufen
     */
    CTabItem[] items = _tabFolder.getItems();
    for (CTabItem item : items)
    {
      SystemObject so = dataModel.getObject((String)item.getData(item.getText()));     
      Composite c = (Composite)item.getControl();
      for (Control children: c.getChildren()) {
        AttributeGroup atg = null;;
        for (String atgPid: getParameterAtgPids()) {
          if (children.getClass().equals(getDataContainerComposite(atgPid))) {
            atg = dataModel.getAttributeGroup(atgPid);
            break;
          }
        }
        if (atg != null) {
          Data data = ((IDataContainer)children).getUpdate();
          if (data != null) {
            resultDataList.add(new ResultData(so, new DataDescription(atg, asp), _connection.getTime(), data));
            containerList.add((IDataContainer)children);
          }
          else {
            // Instanz liefert _data == null
          }
        }
        else {
          // Klasse von children hat kein ATG-Mapping oder ATG nicht gefunden
        }

      }
    }
    
    UrlasserDialog urlasserDialog = new UrlasserDialog( Display.getCurrent().getActiveShell() );
    UrlasserDialogInfo info = urlasserDialog.anzeigen( resultDataList );
    
    if (info.getFehlerInfo() != null) {
      MessageBox mb = new MessageBox( new Shell( Display.getCurrent() ), SWT.ICON_INFORMATION | SWT.OK );
      mb.setText( "Fehler Urlasser" );
      mb.setMessage( info.getFehlerInfo() );
      mb.open();
    }
    else if (info.getEingabeOk()) {
      for (int i = 0; i < containerList.size(); i++) {
        containerList.get(i).setUpdate(resultDataList.get(i).getData());
      }
    }
    
    return info.getEingabeOk();
  }

  @Override
  public void daVDataUpdate( DaVDataUpdateEvent e )
  {
    if ( e != null && e.getResult().getDataState() != DataState.NO_SOURCE)
    {
      String atgPid = e.getResult().getDataDescription().getAttributeGroup().getPid();
      for (String atg: getParameterAtgPids()) {
        if (atg.equals(atgPid)) {
          if (!sperreFuerNeueDaten(atg)) {
            verarbeiteDavDaten( e );
          }
          else {
//            System.out.println( "Neue Daten -> kein Update fr " + atgPid +
//                ", da Sperre fr neue Daten aktiv");
          }
          return;
        }
      }
//      System.out.println( "Keine Verarbeitung fr " + atgPid);
    }
  }

  private void verarbeiteDavDaten( DaVDataUpdateEvent e)
  {
    SystemObject so = e.getResult().getObject();

    CTabItem[] items = _tabFolder.getItems();
    
    //Tab zum Systemobject ermitteln
    CTabItem item = null;
    for (CTabItem ti : items)
    {
      String pid = (String)ti.getData(ti.getText());

      if (pid == so.getPid())
      {
        item = ti;
        break;
      }
    }

    //Tab gefunden
    if (item != null)
    {
      String atgPid = e.getResult().getDataDescription().getAttributeGroup().getPid();
      Class type = getDataContainerComposite(atgPid);
      
      if (type != null) {
        Composite c = (Composite)item.getControl();
                
        for (Control children: c.getChildren()) {
          
          if (type.isInstance(children)) {
            
            int atgIndex = getAtgIndex(atgPid);
            _tabCnt[atgIndex]++;
         
            ((IDataContainer)children).initialize();
                
            Data data = e.getResult().getData();
            if (data == null) {
              AttributeGroup atg = e.getResult().getDataDescription().getAttributeGroup(); 
              data = _connection.createData(atg);
            }
            
            ((IDataContainer)children).setData(data);
            
            ((Composite)children).layout(true);
            c.layout(true);
            
            if (sperreFuerNeueDaten(atgPid)) {
//              System.out.println( "Sperre fr neue Daten aktiv fr " + atgPid);
            }
            
            break;
          }
          
        }
  
      }
    
    }
    
  }

  @Override
  public void dispose()
  {
    super.dispose();
    DaVDataUpdateListener.getInstanz().removeDaVDataUpdateListener( this );
    IWorkbenchPage page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
    if ( page != null )
    {
      page.hideView( this );
    }
  }
  
  protected int getAtgIndex(String atgPid) {
    int atgIndex = -1;
    
    for (String atg: getParameterAtgPids()) {
      atgIndex++;
      if (atg.equals(atgPid)) {
        return atgIndex;
      }
    }
    
    return -1;
  }
  
  private boolean sperreFuerNeueDaten(String atgPid) {
    int atgIndex = getAtgIndex(atgPid);
    
    if (_tabFolder != null && _tabCnt[atgIndex] < _tabFolder.getItemCount()) {
      return false;
    }
    else {
      return true;
    }
  }

}
