/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.pua.basis.sba.xml;

/**
 * Definition den Elemente, Attribute und der Dokumentspezifikationen der XML-Struktur.
 * 
 * @author MO
 * 
 */
public class XmlDefs
{
  /**
   * DocTypeElement Name, ist gleichzeitig der Name des Wurzelelementes.
   */
  public static final String xmlDocTypeElementName = "Tabelle";

  /**
   * XML DocTyp PublicID
   */
  public static final String xmlDocTypePublicId = "-//dambach//DTD Dokument//DE";

  /**
   * XML DTD Doctype bzw. Name der DTD-Datei
   */
  public static final String xmlDocSystemId = "tabelle.dtd";

  /**
   * Element Tabelle, ist das Wurzelelement.
   */
  public static final String ELE_TABELLE = xmlDocTypeElementName;

  /**
   * Element Info
   */
  public static final String ELE_INFO = "Info";

  /**
   * Element Objekte
   */
  public static final String ELE_OBJEKTE = "Objekte";

  /**
   * Element Objekt
   */
  public static final String ELE_OBJEKT = "Objekt";

  /**
   * Attribut Name
   */
  public static final String ATT_NAME = "Name";

  /**
   * Attribut Pid
   */
  public static final String ATT_PID = "Pid";

  /**
   * Element Zeitbereiche
   */
  public static final String ELE_ZEITBEREICHE = "Zeitbereiche";

  /**
   * Element Zeitbereich
   */
  public static final String ELE_ZEITBEREICH = "Zeitbereich";

  /**
   * Attribut von
   */
  public static final String ATT_VON = "Von";

  /**
   * Attribut bis
   */
  public static final String ATT_BIS = "Bis";

  /**
   * Element Archivdatenarten
   */
  public static final String ELE_ARCHIVDATENARTEN = "Archivdatenarten";

  /**
   * Element Archivdatenart
   */
  public static final String ELE_ARCHIVDATENART = "Archivdatenart";

  /**
   * Attribut Art
   */
  public static final String ATT_ART = "Art";

  /**
   * Element Simulationsvariante
   */
  public static final String ELE_SIMULATIONSVARIANTE = "Simulationsvariante";

  /**
   * Element Skriptname
   */
  public static final String ELE_SKRIPTNAME = "Skriptname";

  /**
   * Element ProtokollId
   */
  public static final String ELE_PROTOKOLLID = "ProtokollId";
  
  /**
   * Element Informationstext
   */
  public static final String ELE_INFORMATIONSTEXT = "Informationstext";

  /**
   * Element Kopf
   */
  public static final String ELE_KOPF = "Kopf";

  /**
   * Element Spaltentitel
   */
  public static final String ELE_SPALTENTITEL = "Spaltentitel";

  /**
   * Attribut Beschriftung
   */
  public static final String ATT_BESCHRIFTUNG = "Beschriftung";

  /**
   * Element Zeile
   */
  public static final String ELE_ZEILE = "Zeile";

  /**
   * Element Spalte
   */
  public static final String ELE_SPALTE = "Spalte";

  /**
   * Attribut Wert
   */
  public static final String ATT_WERT = "Wert";
}
