/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.pua.basis.zeitdauer;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FontDialog;
import org.eclipse.swt.widgets.Shell;

/**
 * Liefert den Basisdialog fr die Erfassung von Zeitdauern.
 * 
 * Mit der Methode <code>init(...)</code> knnen Start- und Endzeitpunkt ausgewhlt werden.
 * 
 * Die Methode <code>open()</code> ffnet den Dialog.
 * 
 * @author HofmannJ
 * 
 */
public class PuAZeitDauerDialog
{
  private Shell shell;

  private Display display;

  /**
   * Zeitdauerwhler
   */
  private PuAZeitDauerWaehler _zeitDauerWaehler;

  /**
   * ZeitDauer
   */
  private PuACompositeZeitDauer _dauer = null;

  public PuAZeitDauerDialog(Display display, PuACompositeZeitDauer dauer)
  {
    this.display = display;
    this._dauer = dauer;

    shell = new Shell(display, SWT.APPLICATION_MODAL | SWT.CLOSE);

    // shell.setImage(Activator.getImageDescriptor("icons/kalender/uhr128x128.png").createImage());

    shell.setText("Zeitauswahl");
    shell.setLayout(new RowLayout());

    _zeitDauerWaehler = new PuAZeitDauerWaehler(shell, SWT.FLAT, _dauer);

    if (false)
    {
       FontData fontData = new FontData("Courir", 22, SWT.BOLD);
       _zeitDauerWaehler.setFont(new Font(this.display, fontData));

      FontDialog fd = new FontDialog(shell, SWT.NONE);

      fd.setText("Select Font");
      fd.setRGB(new RGB(0, 0, 255));
      FontData newFont = fd.open();
      if (newFont != null)
      {
        Font fo = new Font(display, newFont);
        _zeitDauerWaehler.setFont(fo);
      }
    }
  }


  /**
   * ffnet den Dialog. Diese Methode darf erst aufgerufen werden, wenn Start und Endzeitpunkt angegebem wurden.
   * 
   */
  public boolean oeffnen()
  {    
    shell.pack();
    shell.open();
    while (!shell.isDisposed())
    {
      if (!display.readAndDispatch())
        display.sleep();
    }
    
    _dauer.aktionNormalisieren();

    return true;
  }
}
