/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/* Segment 13 Bedienung und Visualisierung, Plug-In Streckenprofil 
 * Copyright (C) 2009-2010 BitCtrl Systems GmbH
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information: 
 * BitCtrl Systems GmbH 
 * Weienfelser Strae 67 
 * 04229 Leipzig 
 * Phone: +49 341-490670 
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.streckenprofil.sts.a8.chart;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.NavigableMap;
import java.util.Set;
import java.util.TreeMap;

import org.eclipse.birt.chart.model.Chart;
import org.eclipse.birt.chart.model.ChartWithAxes;
import org.eclipse.birt.chart.model.attribute.AttributeFactory;
import org.eclipse.birt.chart.model.attribute.AxisType;
import org.eclipse.birt.chart.model.attribute.ColorDefinition;
import org.eclipse.birt.chart.model.attribute.Image;
import org.eclipse.birt.chart.model.attribute.IntersectionType;
import org.eclipse.birt.chart.model.attribute.LineAttributes;
import org.eclipse.birt.chart.model.attribute.LineStyle;
import org.eclipse.birt.chart.model.attribute.Marker;
import org.eclipse.birt.chart.model.attribute.MarkerType;
import org.eclipse.birt.chart.model.attribute.Position;
import org.eclipse.birt.chart.model.attribute.TickStyle;
import org.eclipse.birt.chart.model.attribute.impl.ColorDefinitionImpl;
import org.eclipse.birt.chart.model.attribute.impl.ImageImpl;
import org.eclipse.birt.chart.model.component.Axis;
import org.eclipse.birt.chart.model.component.ComponentPackage;
import org.eclipse.birt.chart.model.component.Scale;
import org.eclipse.birt.chart.model.component.Series;
import org.eclipse.birt.chart.model.component.impl.AxisImpl;
import org.eclipse.birt.chart.model.data.NumberDataSet;
import org.eclipse.birt.chart.model.data.SeriesDefinition;
import org.eclipse.birt.chart.model.data.impl.NumberDataElementImpl;
import org.eclipse.birt.chart.model.data.impl.NumberDataSetImpl;
import org.eclipse.birt.chart.model.data.impl.SeriesDefinitionImpl;
import org.eclipse.birt.chart.model.type.BarSeries;
import org.eclipse.birt.chart.model.type.LineSeries;
import org.eclipse.birt.chart.model.type.ScatterSeries;
import org.eclipse.birt.chart.model.type.impl.LineSeriesImpl;
import org.eclipse.birt.chart.model.type.impl.ScatterSeriesImpl;
import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.emf.databinding.EMFObservables;
import org.eclipse.swt.graphics.RGB;

import com.bitctrl.util.CollectionUtilities;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Activator;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Modell;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.StreckenprofilUtil;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AchsenBeschreibung;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AnzeigeQuerschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.LinienEigenschaften;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.MessQuerschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.RealerStreckenAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenEintrag;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenKnoten;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenTeilAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenprofilPackage;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.util.StreckenZugEintragWegBisherComparator;
import de.bsvrz.buv.rw.bitctrl.startup.StartupPlugin;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.Data.Array;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sys.funclib.bitctrl.modell.OnlineDatum;
import de.bsvrz.sys.funclib.bitctrl.modell.SystemObjekt;
import de.bsvrz.sys.funclib.bitctrl.modell.att.Feld;
import de.bsvrz.sys.funclib.bitctrl.modell.fachmodellglobal.attribute.AttOffsetMeter;
import de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.objekte.Anzeige;
import de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.objekte.WvzInhalt;
import de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.onlinedaten.OdAnzeigeEigenschaftIst;
import de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.onlinedaten.OdAnzeigeEigenschaftIst.Daten;
import de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobalzwischenschicht.objekte.WvzInhaltUmsetzung;
import de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobalzwischenschichttls.konfigurationsdaten.KdWvzInhaltUmsetzungTls;
import de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobalzwischenschichttls.objekte.WvzInhaltUmsetzungTls;
import de.bsvrz.sys.funclib.bitctrl.modell.tmkextlsglobal.attribute.AttTlsWzgWvzCode;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.attribute.AtlBetriebsKilometer;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.attribute.AtlVerkehrsBeschraenkungen;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.attribute.AttFahrStreifenLage;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.attribute.AttVerkehrsBeschraenkung;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.konfigurationsdaten.KdBetriebsKilometer;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.konfigurationsdaten.KdFahrStreifen;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.konfigurationsdaten.KdStrassenTeilSegmentVerkehr;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.FahrStreifen;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.StrassenTeilSegment;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.AqCache;

/**
 * Abstrakte Basisklasse fr alle StreckenprofilChartBuilder.
 * 
 * @author BitCtrl Systems GmbH, Hoesel
 * @version $Id: AbstractStreckenprofilBuilder.java,v 1.9 2014/04/17 15:51:12 Pittner Exp $
 */
public abstract class AbstractStreckenprofilBuilder
{

  /**
   * Stringkonstante fr die Y-Achse.
   */
  public static final String LKW_ANTEIL = "LKW Anteil [%]";

  /**
   * Stringkonstante fr die Y-Achse.
   */
  public static final String GESCHWINDIGKEIT_KM_H = "Geschwindigkeit [km / h]";

  /**
   * Stringkonstante fr die Y-Achse.
   */
  public static final String FAHRZEUGDICHTE_FZ_KM = "Fahrzeugdichte [Fz/km]";

  /**
   * Stringkonstante fr die Y-Achse.
   */
  public static final String BEMESSUNGSVERKEHRSSTAERKE_PKW_H = "Bemessungsverkehrsstrke [Pkw/h]";

  /**
   * Stringkonstante fr die Y-Achse.
   */
  public static final String BEMESSUNGSVERKEHRSDICHTE_PKW_KM = "Bemessungsverkehrsdichte [Pkw/km]";

  /**
   * Stringkonstante fr die Y-Achse.
   */
  public static final String ANZAHL_FZ_INTERVALL = "Anzahl [Fz / Intervall]";

  /**
   * Standard Wert fr die Lcke am Anfang bzw. Ende der Datenreihen.
   * 
   * @see {@link org.eclipse.birt.chart.model.component.Axis#setGapWidth(double)}
   * @see {@link org.eclipse.birt.chart.model.component.Axis#getGapWidth()}
   */
  private static final int DEFAULT_GAP_WIDTH = 50;

  /**
   * Die Achse, an der die Datenreihen ausgerichtet werden, mit denen die Beschilderung im Chart angezeigt wird.
   */
  private Axis schilderAchse;

  /**
   * Map mit den Y-Werten (bei Geschwindigkeitsbeschraenkungen) fr alle denkbaren statischen Verkehrsschilder.
   */
  private static final Map<AttVerkehrsBeschraenkungWrapper, Double> STATISCHE_SCHILDER = new HashMap<AttVerkehrsBeschraenkungWrapper, Double>();
  static
  {
    STATISCHE_SCHILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_13_HOECHSTGESCHWINDIGKEIT_10_KM_H, 10d);
    STATISCHE_SCHILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_14_HOECHSTGESCHWINDIGKEIT_20_KM_H, 20d);
    STATISCHE_SCHILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_15_HOECHSTGESCHWINDIGKEIT_30_KM_H, 30d);
    STATISCHE_SCHILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_5_HOECHSTGESCHWINDIGKEIT_40_KM_H, 40d);
    STATISCHE_SCHILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_6_HOECHSTGESCHWINDIGKEIT_50_KM_H, 50d);
    STATISCHE_SCHILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_7_HOECHSTGESCHWINDIGKEIT_60_KM_H, 60d);
    STATISCHE_SCHILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_8_HOECHSTGESCHWINDIGKEIT_70_KM_H, 70d);
    STATISCHE_SCHILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_9_HOECHSTGESCHWINDIGKEIT_80_KM_H, 80d);
    STATISCHE_SCHILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_10_HOECHSTGESCHWINDIGKEIT_100_KM_H, 100d);
    STATISCHE_SCHILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_11_HOECHSTGESCHWINDIGKEIT_120_KM_H, 120d);
    STATISCHE_SCHILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_12_HOECHSTGESCHWINDIGKEIT_130_KM_H, 130d);

  }

  /**
   * Liste mit allen {@link AttTlsWzgWvzCode}s, die eine Geschwindigkeitsbeschrnkung darstellen.
   */
  private static final List<AttTlsWzgWvzCode> ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN = new ArrayList<AttTlsWzgWvzCode>();
  static
  {
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_20__20_KM_H);
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_21__30_KM_H);
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_22__40_KM_H);
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_23__50_KM_H);
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_24__60_KM_H);
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_25__70_KM_H);
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_26__80_KM_H);
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_27__90_KM_H);
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_28__100_KM_H);
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_29__110_KM_H);
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_30__120_KM_H);
    ANZEIGEN_GESCHWINDIGKEITSBESCHRAENKUNGEN.add(AttTlsWzgWvzCode.ZUSTAND_33__130_KM_H);
  }

  /**
   * {@link Map} mit der die {@link AttTlsWzgWvzCode}s auf Geschwindigkeitswerte gemapped werden.
   */
  private static final Map<AttTlsWzgWvzCode, Double> TLS_CODE_GESCHWINDIGKEITEN = new HashMap<AttTlsWzgWvzCode, Double>();
  static
  {
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_20__20_KM_H, 20D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_21__30_KM_H, 30D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_22__40_KM_H, 40D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_23__50_KM_H, 50D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_24__60_KM_H, 60D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_25__70_KM_H, 70D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_26__80_KM_H, 80D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_27__90_KM_H, 90D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_28__100_KM_H, 100D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_29__110_KM_H, 110D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_30__120_KM_H, 120D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_33__130_KM_H, 130D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_40_ENDE_20_KM_H, -20D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_41_ENDE_30_KM_H, -30D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_42_ENDE_40_KM_H, -40D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_43_ENDE_50_KM_H, -50D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_44_ENDE_60_KM_H, -60D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_45_ENDE_70_KM_H, -70D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_46_ENDE_80_KM_H, -80D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_47_ENDE_90_KM_H, -90D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_48_ENDE_100_KM_H, -100D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_49_ENDE_110_KM_H, -110D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_50_ENDE_120_KM_H, -120D);
    TLS_CODE_GESCHWINDIGKEITEN.put(AttTlsWzgWvzCode.ZUSTAND_54_ENDE_130_KM_H, -130D);
  }

  /**
   * Map mit {@link AttTlsWzgWvzCode}s und den dazu passenden Images.
   */
  private static Map<AttTlsWzgWvzCode, Image> tlsCodeIconMap = new HashMap<AttTlsWzgWvzCode, Image>();
  static
  {
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_20__20_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_20_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_21__30_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_30_ICON_MARKER_URL));

    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_22__40_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_40_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_23__50_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_50_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_24__60_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_60_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_25__70_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_70_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_26__80_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_80_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_27__90_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_90_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_28__100_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_100_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_29__110_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_110_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_30__120_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_120_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_33__130_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_130_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_40_ENDE_20_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_20_ENDE_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_41_ENDE_30_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_30_ENDE_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_42_ENDE_40_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_40_ENDE_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_43_ENDE_50_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_50_ENDE_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_44_ENDE_60_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_60_ENDE_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_45_ENDE_70_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_70_ENDE_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_46_ENDE_80_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_80_ENDE_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_47_ENDE_90_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_90_ENDE_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_48_ENDE_100_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_100_ENDE_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_49_ENDE_110_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_110_ENDE_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_50_ENDE_120_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_120_ENDE_ICON_MARKER_URL));
    tlsCodeIconMap.put(AttTlsWzgWvzCode.ZUSTAND_54_ENDE_130_KM_H, ImageImpl
        .create(Activator.DYNAMISCHE_GESCHWINDIGKEITSBESCHRAENKUNG_130_ENDE_ICON_MARKER_URL));
  }

  /**
   * Map mit URLs der Icons, die bei den jeweiligen Verkehrsbeschrnkungen angezeigt werden.
   */
  private static final Map<AttVerkehrsBeschraenkungWrapper, Image> STATISCHE_SCHILDER_BILDER = new HashMap<AttVerkehrsBeschraenkungWrapper, Image>();

  static
  {
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_13_HOECHSTGESCHWINDIGKEIT_10_KM_H, ImageImpl
        .create(Activator.GESCHWINDIGKEITSBESCHRAENKUNG_10_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_14_HOECHSTGESCHWINDIGKEIT_20_KM_H, ImageImpl
        .create(Activator.GESCHWINDIGKEITSBESCHRAENKUNG_20_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_15_HOECHSTGESCHWINDIGKEIT_30_KM_H, ImageImpl
        .create(Activator.GESCHWINDIGKEITSBESCHRAENKUNG_30_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_5_HOECHSTGESCHWINDIGKEIT_40_KM_H, ImageImpl
        .create(Activator.GESCHWINDIGKEITSBESCHRAENKUNG_40_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_6_HOECHSTGESCHWINDIGKEIT_50_KM_H, ImageImpl
        .create(Activator.GESCHWINDIGKEITSBESCHRAENKUNG_50_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_7_HOECHSTGESCHWINDIGKEIT_60_KM_H, ImageImpl
        .create(Activator.GESCHWINDIGKEITSBESCHRAENKUNG_60_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_8_HOECHSTGESCHWINDIGKEIT_70_KM_H, ImageImpl
        .create(Activator.GESCHWINDIGKEITSBESCHRAENKUNG_60_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_9_HOECHSTGESCHWINDIGKEIT_80_KM_H, ImageImpl
        .create(Activator.GESCHWINDIGKEITSBESCHRAENKUNG_80_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_10_HOECHSTGESCHWINDIGKEIT_100_KM_H, ImageImpl
        .create(Activator.GESCHWINDIGKEITSBESCHRAENKUNG_100_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_11_HOECHSTGESCHWINDIGKEIT_120_KM_H, ImageImpl
        .create(Activator.GESCHWINDIGKEITSBESCHRAENKUNG_120_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_12_HOECHSTGESCHWINDIGKEIT_130_KM_H, ImageImpl
        .create(Activator.GESCHWINDIGKEITSBESCHRAENKUNG_130_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_1_UEBERHOLVERBOT, ImageImpl
        .create(Activator.UEBERHOLVERBOT_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_0_SONSTIGE, null);
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_2_UEBERHOLVERBOT_FUER_LKW, ImageImpl
        .create(Activator.UEBERHOLVERBOT_LKW_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_3_UEBERHOLVERBOT_BEI_NAESSE, ImageImpl
        .create(Activator.UEBERHOLVERBOT_BEI_NAESSE_80_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_4_HOECHSTGEWINDIGKEIT_ALLGEMEIN, null);

    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_17_ENDE_VERKEHRSBESCHRAENKUNG, ImageImpl
        .create(Activator.BESCHRAENKUNG_ENDE_ICON_MARKER_URL));
    STATISCHE_SCHILDER_BILDER.put(AttVerkehrsBeschraenkungWrapper.ZUSTAND_16_ENDE_GESCHWINDIGKEITSBESCHRAENKUNG,
        ImageImpl.create(Activator.BESCHRAENKUNG_ENDE_ICON_MARKER_URL));

  }

  /**
   * {@link SeriesDefinition} mit der die Geschwindigkeitsbeschrnkungen als rote Linie dargestellt werden.
   */
  private SeriesDefinition verkehrsBeschreankungsSeriesDefinition;

  /**
   * {@link SeriesDefinition} mit der die Verkehrsbeschrnkungen mit Schildsymbolen dargestellt werden.
   */
  private SeriesDefinition verkehrsBeschreankungSchilderSeriesDefinition;

  /**
   * Font name for all titles, labels, and values.
   */
  protected static final String FONT_NAME = "MS Sans Serif";

  /**
   * Konstante fr ein mittleres Grau.
   */
  protected static final ColorDefinition MIDDLE_GREY = ColorDefinitionImpl.create(160, 160, 160);

  /**
   * Konstante fr dunkles Grau.
   */
  protected static final ColorDefinition DARK_GREY = ColorDefinitionImpl.create(127, 127, 127);

  /**
   * Default Gre der Schrift fr die Titel der Achsen.
   */
  protected static final int DEFAULT_AXIS_LABEL_TEXT_SIZE = 8;

  /**
   * Der Inhalt der Konfigurationsseite in Form eines {@link Modell}.
   */
  private final Modell streckenprofilModel;

  /**
   * Der Anzeigequerschnitt - Cache.
   */
  private final AqCache aqcache;

  /**
   * Map mit allen X-Werten, die im Chart versorgt werden mssen.
   */
  private final TreeMap<Double, Double> streckenprofilPositionenMap = new TreeMap<Double, Double>();

  /**
   * Abstrakter Konstruktor fr Builder Klassen von Streckenprofilen.
   * 
   * @param model
   *          das Streckenprofil.
   */
  public AbstractStreckenprofilBuilder(final Modell model)
  {
    super();
    streckenprofilModel = model;
    final StartupPlugin startupPlugin = StartupPlugin.getDefault();
    aqcache = startupPlugin.getDefaultAqCache();
  }

  /**
   * Wandert das Streckenprofil von vorn nach hinten durch und merkt sich alle Wegmarkierungen die von Bedeutung sein
   * knnten. Das sind u.A. die Position der {@link MessQuerschnitt}e und der {@link AnzeigeQuerschnitt}e Damit kann man
   * dann die X-Achse des Charts versorgen.
   * 
   * @return liefert ein Map mit allen Punkten der X - Achse und den dazugehrigen Y Default Werten (<code>null</code>).
   */
  protected Map<Double, Double> ermittleMQWegeValues()
  {
    final TreeMap<Double, Double> result = new TreeMap<Double, Double>();
    result.put(0D, null);
    StreckenKnoten knoten = streckenprofilModel.getErsterStreckenKnoten();
    while (knoten != null && knoten.getNachStrecke() != null)
    {
      final List<RealerStreckenAbschnitt<?>> abschnittListe = new ArrayList<RealerStreckenAbschnitt<?>>();
      abschnittListe.add(knoten.getAktiverStreckenAbschnitt());
      abschnittListe.add(knoten.getNachStrecke().getAktiverStreckenAbschnitt());

      for (final RealerStreckenAbschnitt<?> abschnitt : abschnittListe)
      {
        if (abschnitt != null)
        {
          for (final StreckenTeilAbschnitt sta : abschnitt.getStreckenTeilAbschnitt())
          {
            final KdStrassenTeilSegmentVerkehr.Daten d = sta.getModellObjekt().getKdStrassenTeilSegmentVerkehr()
                .getDatum();
            if (d != null)
            {
              final double weg = sta.getWegBisher();
              result.put(weg, null);
              result.put(weg + 1, null);
              result.put(weg + sta.getLaenge() - 1, null);
            }
          }
          for (final AnzeigeQuerschnitt aq : abschnitt.getAnzeigeQuerschnitt())
          {
            result.put(aq.getWegBisher(), null);
          }
        }
      }
      knoten = knoten.getNachStrecke().getNachKnoten();
    }
    final StreckenKnoten letzterStreckenKnoten = streckenprofilModel.getLetzterStreckenKnoten();
    if (letzterStreckenKnoten != null && letzterStreckenKnoten.getLaenge() != null)
    {
      result.put(letzterStreckenKnoten.getWegBisher() + letzterStreckenKnoten.getLaenge(), null);
    }

    for (final MessQuerschnitt mq : streckenprofilModel.getAlleMessquerschnitte(true))
    {
      final double weg = mq.getWegBisher();
      result.put(weg, null);
    }

    result.put(result.lastKey() + 1400, null);

    return result;
  }

  /**
   * Bestimmt die Sichtbarkeit der Datenreihe anhand des Attributes aus den Linieneinstellungen.
   * 
   * @param lp
   *          die Linieneinstellungen
   * @param s
   *          die Datenreihe
   */
  protected void initSeriesVisibility(final LinienEigenschaften lp, final Series s)
  {
    final IObservableValue target = EMFObservables.observeValue(s, ComponentPackage.Literals.SERIES__VISIBLE);
    final IObservableValue model = EMFObservables.observeValue(lp,
        StreckenprofilPackage.Literals.LINIEN_EIGENSCHAFTEN__VISIBLE);
  }

  /**
   * Initialisiert die Farbe der Darstellung.
   * 
   * @param lp
   *          die Linien- bzw. Balkeneinstellungen
   * @param bs
   *          die Datenreihe
   */
  protected void initBarColor(final LinienEigenschaften lp, final BarSeries bs)
  {

    final ColorDefinition colorDef = AttributeFactory.eINSTANCE.createColorDefinition();
    colorDef.setBlue(lp.getRgb().blue);
    colorDef.setGreen(lp.getRgb().green);
    colorDef.setRed(lp.getRgb().red);

    bs.setRiserOutline(colorDef);

  }

  /**
   * Initialisiern der Liniendicke (inkl. Databinding)
   * 
   * @param lp
   *          die Linieneinstellungen
   * @param ls
   *          die Datenreihe.
   */
  protected void initLineThickness(final LinienEigenschaften lp, final LineSeries ls)
  {
    final LineAttributes lineAttributes = ls.getLineAttributes();

    lineAttributes.setThickness(lp.getLineThickness().getValue() + 1);
  }

  /**
   * Initialisieren der Linienfarbe (inkl. Databinding).
   * 
   * @param lp
   *          Eigenschaften Linie im Modell.
   * @param ls
   *          Beschreibung der Linie im Chart.
   */
  protected void initLineColor(final LinienEigenschaften lp, final LineSeries ls)
  {
    final LineAttributes lineAttributes = ls.getLineAttributes();

    for (final Marker m : ls.getMarkers())
    {
      m.setType(lp.getKnotenArt());
      if (MarkerType.ICON_LITERAL.equals(lp.getKnotenArt()))
      {
        m.setFill(ImageImpl.create(Activator.MARKERTYPE_ICON_ICON_MARKER_URL));
      }

    }

    final ColorDefinition colorDef = AttributeFactory.eINSTANCE.createColorDefinition();
    colorDef.setBlue(lp.getRgb().blue);
    colorDef.setGreen(lp.getRgb().green);
    colorDef.setRed(lp.getRgb().red);

    lineAttributes.setColor(colorDef);

  }

  /**
   * Initialisieren des LineStyles (inkl. Databinding).
   * 
   * @param lp
   *          Eigenschaften Linie im Modell.
   * @param ls
   *          Beschreibung der Linie im Chart.
   */
  protected void initLineStyle(final LinienEigenschaften lp, final LineSeries ls)
  {
    final LineAttributes lineAttributes = ls.getLineAttributes();

    lineAttributes.setStyle(lp.getLineStyle());
  }

  /**
   * Methode zum Malen von Icons innerhalb des Chart.
   * 
   * @param geschwindigkeitsAchse
   *          die Achse an der die Icons sicht orientieren.
   * @param iconWerteMap
   *          die Menge aller Positionen (auf der X Achse) und die dazugehrigen Werte.
   * 
   */
  protected void erzeugeStatischeGeschwindigkeitsBegrenzungsIcons(final Axis geschwindigkeitsAchse,
      final Map<Double, Double> iconWerteMap)
  {

    if (verkehrsBeschreankungSchilderSeriesDefinition == null)
    {
      verkehrsBeschreankungSchilderSeriesDefinition = SeriesDefinitionImpl.create();

      schilderAchse = AxisImpl.create(Axis.ORTHOGONAL);
      schilderAchse.getLineAttributes().setVisible(false);
      schilderAchse.getLabel().setVisible(false);
      final Scale scale = schilderAchse.getScale();
      scale.setMin(NumberDataElementImpl.create(0));
      scale.setMax(NumberDataElementImpl.create(1));
      scale.setStepNumber(1);
      ((ChartWithAxes)getChart()).getPrimaryBaseAxes()[0].getAssociatedAxes().add(schilderAchse);
      schilderAchse.getSeriesDefinitions().add(verkehrsBeschreankungSchilderSeriesDefinition);
    }

    final Map<StreckenTeilAbschnitt, List<AttVerkehrsBeschraenkungWrapper>> tmpMap = ermittleVerkehrsBeschraenkungsIcons();
    final Map<AttVerkehrsBeschraenkungWrapper, List<StreckenTeilAbschnitt>> beschraenkungsMap = new HashMap<AttVerkehrsBeschraenkungWrapper, List<StreckenTeilAbschnitt>>();
    for (final StreckenTeilAbschnitt sta : tmpMap.keySet())
    {
      final List<AttVerkehrsBeschraenkungWrapper> beschraenkungen = tmpMap.get(sta);
      for (final AttVerkehrsBeschraenkungWrapper b : beschraenkungen)
      {
        if (!beschraenkungsMap.containsKey(b))
        {
          beschraenkungsMap.put(b, new ArrayList<StreckenTeilAbschnitt>());
        }
        beschraenkungsMap.get(b).add(sta);
      }
    }

    for (final AttVerkehrsBeschraenkungWrapper typ : beschraenkungsMap.keySet())
    {

      if (STATISCHE_SCHILDER_BILDER.get(typ) == null)
      {
        continue;
      }

      Double vertikalePosition = 1d;
      if (AttVerkehrsBeschraenkungWrapper.getZustaendeGeschwindigkeitsbeschaenkung().contains(typ)
          || AttVerkehrsBeschraenkungWrapper.ZUSTAND_16_ENDE_GESCHWINDIGKEITSBESCHRAENKUNG.equals(typ))
      {
        vertikalePosition = 1d;
      }
      else
      {
        vertikalePosition = 0.9d;
      }

      final List<StreckenTeilAbschnitt> staListe = beschraenkungsMap.get(typ);
      final Map<Double, Double> result = new TreeMap<Double, Double>();
      result.putAll(iconWerteMap);

      for (final StreckenTeilAbschnitt sta : staListe)
      {
        if (result.containsKey(sta.getWegBisher() + 1))
        {
          result.put(sta.getWegBisher() + 1, vertikalePosition);
        }
      }

      final NumberDataSet orthoValuesDataSet1 = NumberDataSetImpl.create(result.values());
      final String seriesID = typ.toString();
      final ScatterSeries ls = (ScatterSeries)ScatterSeriesImpl.create();
      ls.setSeriesIdentifier(seriesID);

      ls.setDataSet(orthoValuesDataSet1);

      for (int i = 0; i < ls.getMarkers().size(); i++)
      {
        ls.getMarkers().get(i).setType(MarkerType.ICON_LITERAL);
        ls.getMarkers().get(i).setSize(12);
        ls.getMarkers().get(i).setFill(STATISCHE_SCHILDER_BILDER.get(typ).copyInstance());
      }
      verkehrsBeschreankungSchilderSeriesDefinition.getSeries().add(ls);

    }
  }

  /**
   * Ermittelt die Verkehrsbeschrnkungen, die durch die statische Beschilderung vorgegeben werden.
   * 
   * @return Menge der {@link StreckenTeilAbschnitt}e mit zugehrigen Verkehrsbeschrnkungen.
   */
  public Map<StreckenTeilAbschnitt, List<AttVerkehrsBeschraenkungWrapper>> ermittleVerkehrsBeschraenkungsIcons()
  {
    final Map<StreckenTeilAbschnitt, List<AttVerkehrsBeschraenkungWrapper>> iconLineMap = new TreeMap<StreckenTeilAbschnitt, List<AttVerkehrsBeschraenkungWrapper>>(
        new StreckenZugEintragWegBisherComparator());

    StreckenEintrag streckenEintrag = streckenprofilModel.getErsterStreckenKnoten();
    final ArrayList<AttVerkehrsBeschraenkungWrapper> neueBeschraenkungen = new ArrayList<AttVerkehrsBeschraenkungWrapper>();
    final List<AttVerkehrsBeschraenkungWrapper> letzteBeschraenkungen = new ArrayList<AttVerkehrsBeschraenkungWrapper>();

    while (streckenEintrag != null)
    {

      final List<RealerStreckenAbschnitt<?>> abschnittListe = new ArrayList<RealerStreckenAbschnitt<?>>();

      if (streckenEintrag instanceof StreckenAbschnitt)
      {
        abschnittListe.add(((StreckenAbschnitt)streckenEintrag).getAktiverStreckenAbschnitt());
      }
      else if (streckenEintrag instanceof StreckenKnoten)
      {
        abschnittListe.add(((StreckenKnoten)streckenEintrag).getAktiverStreckenAbschnitt());
      }

      for (final RealerStreckenAbschnitt<?> abschnitt : abschnittListe)
      {
        if (abschnitt != null)
        {
          for (final StreckenTeilAbschnitt sta : abschnitt.getStreckenTeilAbschnitt())
          {
            final StrassenTeilSegment sts = sta.getModellObjekt();
            if (sts != null)
            {
              final KdStrassenTeilSegmentVerkehr.Daten stsDaten = sts.getKdStrassenTeilSegmentVerkehr().getDatum();
              if (stsDaten != null)
              {
                final Feld<AtlVerkehrsBeschraenkungen> beschraenkungen = stsDaten.getVerkehrsBeschraenkungen();

                for (final AtlVerkehrsBeschraenkungen verkb : beschraenkungen)
                {
                  final AttVerkehrsBeschraenkung typ = verkb.getTyp();
                  final AttVerkehrsBeschraenkungWrapper typWrapper = AttVerkehrsBeschraenkungWrapper.getZustand(typ
                      .getValue());
                  neueBeschraenkungen.add(typWrapper);
                  if (letzteBeschraenkungen.contains(typWrapper))
                  {
                    // damit wir nicht so
                    // viele
                    // Schilder
                    // malen
                    continue;
                  }

                  if (typWrapper != null)
                  {
                    if (!iconLineMap.containsKey(sta))
                    {
                      iconLineMap.put(sta, new ArrayList<AttVerkehrsBeschraenkungWrapper>());
                    }
                    iconLineMap.get(sta).add(typWrapper);
                  }
                }

                for (final AttVerkehrsBeschraenkungWrapper letztBeschr : letzteBeschraenkungen)
                {
                  if (AttVerkehrsBeschraenkungWrapper.getZustaendeAllgemeineVerkehrsBeschraenkung().contains(
                      letztBeschr)
                      && CollectionUtilities.intersection(neueBeschraenkungen, letzteBeschraenkungen).isEmpty())
                  {
                    if (!iconLineMap.containsKey(sta))
                    {
                      iconLineMap.put(sta, new ArrayList<AttVerkehrsBeschraenkungWrapper>());
                    }
                    iconLineMap.get(sta).add(AttVerkehrsBeschraenkungWrapper.ZUSTAND_17_ENDE_VERKEHRSBESCHRAENKUNG);

                  }
                  else if (AttVerkehrsBeschraenkungWrapper.getZustaendeGeschwindigkeitsbeschaenkung().contains(
                      letztBeschr)
                      && CollectionUtilities.intersection(
                          AttVerkehrsBeschraenkungWrapper.getZustaendeGeschwindigkeitsbeschaenkung(),
                          neueBeschraenkungen).isEmpty())
                  {
                    if (!iconLineMap.containsKey(sta))
                    {
                      iconLineMap.put(sta, new ArrayList<AttVerkehrsBeschraenkungWrapper>());
                    }
                    iconLineMap.get(sta).add(
                        AttVerkehrsBeschraenkungWrapper.ZUSTAND_16_ENDE_GESCHWINDIGKEITSBESCHRAENKUNG);

                  }
                }
                letzteBeschraenkungen.clear();
                letzteBeschraenkungen.addAll(neueBeschraenkungen);
                neueBeschraenkungen.clear();
              }
            }
          }
        }
      }

      if (streckenEintrag instanceof StreckenAbschnitt)
      {
        streckenEintrag = ((StreckenAbschnitt)streckenEintrag).getNachKnoten();

      }
      else if (streckenEintrag instanceof StreckenKnoten)
      {
        streckenEintrag = ((StreckenKnoten)streckenEintrag).getNachStrecke();
      }
    }

    return iconLineMap;
  }

  /**
   * Methode zum zeichnen von Linien, die die aktuellen Geschwindigkeitsbegrenzungen darstellen. Es wird nur gezeichnet,
   * wenn die Y-Achse mit den Geschwindigkeiten sichtbar ist.
   * 
   * @param geschwindigkeitsAchse
   *          die Y Achse, an der sich Darstellung der Geschwindigkeitsbegenzung orientiert.
   */
  protected void erzeugeGeschwindigkeitsBegrenzungsLinien(final Axis geschwindigkeitsAchse)
  {
    if (geschwindigkeitsAchse != null)
    {

      if (verkehrsBeschreankungsSeriesDefinition == null)
      {
        verkehrsBeschreankungsSeriesDefinition = SeriesDefinitionImpl.create();
        geschwindigkeitsAchse.getSeriesDefinitions().add(verkehrsBeschreankungsSeriesDefinition);
      }

      final TreeMap<Double, Double> result = ermittleStatischeSchildDaten();

      if (streckenprofilModel.getChartProperties().isAnzeigeQuerschnitteIcons())
      {
        final TreeMap<Double, Double> anzeigenResult = ermittleAnzeigenDaten();
        for (final Double position : anzeigenResult.keySet())
        {
          final Double wert = anzeigenResult.get(position);
          if (wert != null && wert > 0D)
          {
            result.put(position, wert);
          }
        }
      }

      final NumberDataSet orthoValuesDataSet1 = NumberDataSetImpl.create(result.values());
      final String seriesID = "Geschw - Max";
      final LineSeries ls = (LineSeries)LineSeriesImpl.create();
      ls.setSeriesIdentifier(seriesID);
      for (final Series alteSeries : verkehrsBeschreankungsSeriesDefinition.getSeries())
      {
        if (alteSeries.getSeriesIdentifier().equals(seriesID))
        {
          verkehrsBeschreankungsSeriesDefinition.getSeries().remove(alteSeries);
          break;
        }
      }

      ls.setDataSet(orthoValuesDataSet1);

      for (int i = 0; i < ls.getMarkers().size(); i++)
      {
        ls.getMarkers().get(i).setVisible(false);
      }

      ls.setConnectMissingValue(false);
      ls.getLineAttributes().setColor(ColorDefinitionImpl.create(255, 0, 0));
      ls.getLineAttributes().setThickness(10);
      verkehrsBeschreankungsSeriesDefinition.getSeries().add(ls);
    }
  }

  /**
   * Liefert eine {@link Map} in der die Geschwindigkeitsbeschrnkungen der {@link AnzeigeQuerschnitt}e mit Position und
   * Wert vermerkt sind.
   * 
   * @return eine Map mit den Geschwindigkeitsbeschrnkungen der {@link AnzeigeQuerschnitt}e an der jeweiligen Position
   *         im Streckenprofil.
   */
  private TreeMap<Double, Double> ermittleAnzeigenDaten()
  {
    final TreeMap<Double, Double> result = new TreeMap<Double, Double>();
    result.putAll(streckenprofilPositionenMap);

    final TreeMap<Double, AttTlsWzgWvzCode> codeMap = new TreeMap<Double, AttTlsWzgWvzCode>();

    for (final AnzeigeQuerschnitt aq : streckenprofilModel.getAlleAnzeigequerschnitte())
    {
      final Collection<Anzeige> anzeigen = aq.getModellObjekt().getAnzeigen();
      for (final Anzeige anzeige : anzeigen)
      {
        if (anzeige.getFahrStreifen() != null)
        {
          for (final FahrStreifen f : anzeige.getFahrStreifen())
          {
            final KdFahrStreifen.Daten lage = f.getKdFahrStreifen().getDatum();
            if (lage != null && AttFahrStreifenLage.ZUSTAND_0_HFS.equals(lage.getLage()))
            {
              final OdAnzeigeEigenschaftIst.Daten datenAnzeigeEigenschaftIst = anzeige.getOdAnzeigeEigenschaftIst()
                  .getDatum(OdAnzeigeEigenschaftIst.Aspekte.AqZustand);
              if (datenAnzeigeEigenschaftIst != null
                  && OnlineDatum.Status.DATEN.equals(datenAnzeigeEigenschaftIst.dGetDatenStatus()))
              {
                final WvzInhalt inhalt = datenAnzeigeEigenschaftIst.getEigenschaft().getAnzeigeInhalt();
                if (inhalt != null)
                {
                  final WvzInhaltUmsetzung umsetzung = aqcache.getWvzInhaltUmsetzung(inhalt);
                  if (umsetzung instanceof WvzInhaltUmsetzungTls)
                  {
                    final WvzInhaltUmsetzungTls umsetzungTls = (WvzInhaltUmsetzungTls)umsetzung;
                    final KdWvzInhaltUmsetzungTls.Daten tlsDaten = umsetzungTls.getKdWvzInhaltUmsetzungTls().getDatum();
                    if (tlsDaten != null)
                    {
                      codeMap.put(aq.getWegBisher(), tlsDaten.getCode());
                    }
                  }
                }
              }
            }
          }
        }
      }
    }

    final Double last = result.lastKey();
    for (final Double d : codeMap.keySet())
    {
      final NavigableMap<Double, Double> teilMap = result.subMap(d, true, last, true);
      for (final Double position : teilMap.keySet())
      {
        result.put(position, TLS_CODE_GESCHWINDIGKEITEN.get(codeMap.get(d)));
      }
    }

    return result;
  }

  // private Long holeBetriebskilometerStrassenTeilSegment(SystemObject object3){
  // new ArrayLLong re = null;
  //    
  // AttributeGroup atg3 = object3.getDataModel().getAttributeGroup("atg.betriebsKilometer");
  // Data cd3 = object3.getConfigurationData(atg3);
  // if (cd3 != null)
  // {
  // Array array = cd3.getItem("BetriebsKilometer").asArray();
  // for (int i = 0; i < array.getLength(); i++)
  // {
  // Data item4 = array.getItem(i).getItem("Wert");
  //
  // if (item4 != null)
  // {
  // re = item4.asUnscaledValue().longValue();
  // }
  // else
  // {
  //
  // }
  // }
  // }
  // return re;
  // }

  /**
   * Ermittelt die erlaubten maximal Geschwindigkeiten an den jeweiligen Teilabschnitten.
   * 
   * @return ein Map mit der Position auf unserem Streckenzug und der zugehrigen Hchstgeschwindigkeit.
   */
  public TreeMap<Double, Double> ermittleStatischeSchildDaten2()
  {
    final TreeMap<Double, Double> result = new TreeMap<Double, Double>();
    TreeMap<Double, Double> tmp = ermittleStatischeSchildDaten();

    Map<StreckenTeilAbschnitt, List<AttVerkehrsBeschraenkungWrapper>> beschraenkungen = ermittleVerkehrsBeschraenkungsIcons();
    for (Map.Entry<StreckenTeilAbschnitt, List<AttVerkehrsBeschraenkungWrapper>> me : beschraenkungen.entrySet())
    {
      StreckenTeilAbschnitt sta = me.getKey();
      List<AttVerkehrsBeschraenkungWrapper> list = me.getValue();
      for (AttVerkehrsBeschraenkungWrapper att : list)
      {
//        System.out.println(sta.getName() + " -> " + sta.getWegBisher() + " -> " + att);
        Double value = 0.0;
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_13_HOECHSTGESCHWINDIGKEIT_10_KM_H)){
          value = 10.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_14_HOECHSTGESCHWINDIGKEIT_20_KM_H)){
          value = 20.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_15_HOECHSTGESCHWINDIGKEIT_30_KM_H)){
          value = 30.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_5_HOECHSTGESCHWINDIGKEIT_40_KM_H)){
          value = 40.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_6_HOECHSTGESCHWINDIGKEIT_50_KM_H)){
          value = 50.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_7_HOECHSTGESCHWINDIGKEIT_60_KM_H)){
          value = 60.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_8_HOECHSTGESCHWINDIGKEIT_70_KM_H)){
          value = 70.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_9_HOECHSTGESCHWINDIGKEIT_80_KM_H)){
          value = 80.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_10_HOECHSTGESCHWINDIGKEIT_100_KM_H)){
          value = 100.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_11_HOECHSTGESCHWINDIGKEIT_120_KM_H)){
          value = 120.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_12_HOECHSTGESCHWINDIGKEIT_130_KM_H)){
          value = 130.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_16_ENDE_GESCHWINDIGKEITSBESCHRAENKUNG)){
          value = 500.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_17_ENDE_VERKEHRSBESCHRAENKUNG)){
          value = 510.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_1_UEBERHOLVERBOT)){
          value = 520.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_2_UEBERHOLVERBOT_FUER_LKW)){
          value = 530.0;
        }
        if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_3_UEBERHOLVERBOT_BEI_NAESSE)){
          value = 540.0;
        }
        
        Double wegBisher = sta.getWegBisher();
        if (wegBisher != null){
//          if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_16_ENDE_GESCHWINDIGKEITSBESCHRAENKUNG)
//              || att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_17_ENDE_VERKEHRSBESCHRAENKUNG)
//              )
//            result.put(wegBisher + 1, value);
//          else
            result.put(wegBisher, value);
        }
      }
        
//        KdBetriebsKilometer cd = sta.getModellObjekt().getKdBetriebsKilometer();
//        Feld<AtlBetriebsKilometer> atlBkms = cd.getDatum().getBetriebsKilometer();
//        for (AtlBetriebsKilometer atlBkm : atlBkms)
//        {
//          AttOffsetMeter wert = atlBkm.getWert();
//          if (wert != null)
//          {
//            double km = wert.doubleValue();
//            if (att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_16_ENDE_GESCHWINDIGKEITSBESCHRAENKUNG)
//                || att.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_17_ENDE_VERKEHRSBESCHRAENKUNG))
////              km += sta.getLaenge();            
//            result.put(km, value);
//          }
//        }
//      }
//      if (tmp.containsKey(sta.getWegBisher()))
//      {
//        
//      }else{
//        System.out.println("else: " + sta.getName() + " -> " + beschraenkungen.get(sta).size());
//      }
    }

    return tmp;
  }
  
  /**
   * Ermittelt die erlaubten maximal Geschwindigkeiten an den jeweiligen Teilabschnitten.
   * 
   * @return ein Map mit der Position auf unserem Streckenzug und der zugehrigen Hchstgeschwindigkeit.
   */
  public TreeMap<Double, Double> ermittleStatischeSchildDaten3()
  {
    return ermittleStatischeSchildDaten3(false);
  }
  
  
  /**
   * Ermittelt die erlaubten maximal Geschwindigkeiten an den jeweiligen Teilabschnitten.
   * 
   * @return ein Map mit der Position auf unserem Streckenzug und der zugehrigen Hchstgeschwindigkeit.
   */
  public TreeMap<Double, Double> ermittleStatischeSchildDaten3(boolean flag)
  {
    final TreeMap<Double, Double> result = new TreeMap<Double, Double>();
    final Map<StreckenTeilAbschnitt, List<AttVerkehrsBeschraenkungWrapper>> tmpMap = ermittleVerkehrsBeschraenkungsIcons();
    final Map<AttVerkehrsBeschraenkungWrapper, List<StreckenTeilAbschnitt>> beschraenkungsMap = new HashMap<AttVerkehrsBeschraenkungWrapper, List<StreckenTeilAbschnitt>>();
    for (final StreckenTeilAbschnitt sta : tmpMap.keySet())
    {
      final List<AttVerkehrsBeschraenkungWrapper> beschraenkungen = tmpMap.get(sta);
      for (final AttVerkehrsBeschraenkungWrapper b : beschraenkungen)
      {
        if (!beschraenkungsMap.containsKey(b))
        {
          beschraenkungsMap.put(b, new ArrayList<StreckenTeilAbschnitt>());
        }
        beschraenkungsMap.get(b).add(sta);
      }
    }

    for (final AttVerkehrsBeschraenkungWrapper typ : beschraenkungsMap.keySet())
    {
      if (STATISCHE_SCHILDER_BILDER.get(typ) == null)
      {
        continue;
      }

      final List<StreckenTeilAbschnitt> staListe = beschraenkungsMap.get(typ);

      for (final StreckenTeilAbschnitt sta : staListe)
      {        
        Double value = 0.0;
                
        if (!flag){          
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_13_HOECHSTGESCHWINDIGKEIT_10_KM_H)){
            value = 10.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_14_HOECHSTGESCHWINDIGKEIT_20_KM_H)){
            value = 20.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_15_HOECHSTGESCHWINDIGKEIT_30_KM_H)){
            value = 30.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_5_HOECHSTGESCHWINDIGKEIT_40_KM_H)){
            value = 40.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_6_HOECHSTGESCHWINDIGKEIT_50_KM_H)){
            value = 50.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_7_HOECHSTGESCHWINDIGKEIT_60_KM_H)){
            value = 60.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_8_HOECHSTGESCHWINDIGKEIT_70_KM_H)){
            value = 70.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_9_HOECHSTGESCHWINDIGKEIT_80_KM_H)){
            value = 80.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_10_HOECHSTGESCHWINDIGKEIT_100_KM_H)){
            value = 100.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_11_HOECHSTGESCHWINDIGKEIT_120_KM_H)){
            value = 120.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_12_HOECHSTGESCHWINDIGKEIT_130_KM_H)){
            value = 130.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_16_ENDE_GESCHWINDIGKEITSBESCHRAENKUNG)){
            value = 500.0;
          }
          if (value > 0.0)
            result.put(sta.getWegBisher(), value);
          else{
//            System.out.println("else1: " + typ);
          }
        }else{
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_17_ENDE_VERKEHRSBESCHRAENKUNG)){
            value = 510.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_1_UEBERHOLVERBOT)){
            value = 520.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_2_UEBERHOLVERBOT_FUER_LKW)){
            value = 530.0;
          }
          if (typ.equals(AttVerkehrsBeschraenkungWrapper.ZUSTAND_3_UEBERHOLVERBOT_BEI_NAESSE)){
            value = 540.0;
          }          
          if (value > 0.0)
            result.put(sta.getWegBisher(), value);
          else{
//            System.out.println("else2: " + typ);
          }
        }
      }
    }
    return result;
  }

  /**
   * Ermittelt die erlaubten maximal Geschwindigkeiten an den jeweiligen Teilabschnitten.
   * 
   * @return ein Map mit der Position auf unserem Streckenzug und der zugehrigen Hchstgeschwindigkeit.
   */
  public TreeMap<Double, Double> ermittleStatischeSchildDaten()
  {
    final TreeMap<Double, Double> result = new TreeMap<Double, Double>();
    result.putAll(streckenprofilPositionenMap);
    final Map<StreckenTeilAbschnitt, List<AttVerkehrsBeschraenkungWrapper>> beschraenkungen = ermittleVerkehrsBeschraenkungsIcons();

    StreckenTeilAbschnitt letzterTeilAbschnitt = null;
    AttVerkehrsBeschraenkungWrapper letzteGeschwindigkeitsBeschraenkung = null;
    if (beschraenkungen.keySet().size() == 1)
    {
      final StreckenTeilAbschnitt sta = beschraenkungen.keySet().iterator().next();
      if (result.containsKey(sta.getWegBisher()))
      {
        for (final AttVerkehrsBeschraenkungWrapper wrapper : beschraenkungen.get(sta))
        {
          if (AttVerkehrsBeschraenkungWrapper.getZustaendeGeschwindigkeitsbeschaenkung().contains(wrapper))
          {
            result.put(sta.getWegBisher(), STATISCHE_SCHILDER.get(wrapper));
            break;
          }
        }
      }
    }
    else
    {
      for (final StreckenTeilAbschnitt sta : beschraenkungen.keySet())
      {
        AttVerkehrsBeschraenkungWrapper aktuelleGeschwindigkeitsBeschraenkung = null;
        for (final AttVerkehrsBeschraenkungWrapper b : beschraenkungen.get(sta))
        {

          if (AttVerkehrsBeschraenkungWrapper.getZustaendeGeschwindigkeitsbeschaenkung().contains(b))
          {
            aktuelleGeschwindigkeitsBeschraenkung = b;
            break;
          }
        }

        if (letzterTeilAbschnitt != null && letzteGeschwindigkeitsBeschraenkung != null
            && result.containsKey(letzterTeilAbschnitt.getWegBisher()) && result.containsKey(sta.getWegBisher()))
        {
          final Map<Double, Double> mapTeilabschnitt = new TreeMap<Double, Double>();
          mapTeilabschnitt.putAll(result.subMap(letzterTeilAbschnitt.getWegBisher(), true, sta.getWegBisher(), true));
          for (final Double d : mapTeilabschnitt.keySet())
          {
            mapTeilabschnitt.put(d, STATISCHE_SCHILDER.get(letzteGeschwindigkeitsBeschraenkung));
          }
          result.putAll(mapTeilabschnitt);
        }

        letzterTeilAbschnitt = sta;
        letzteGeschwindigkeitsBeschraenkung = aktuelleGeschwindigkeitsBeschraenkung;
      }
    }

    if (letzterTeilAbschnitt != null && letzteGeschwindigkeitsBeschraenkung != null)
    {

      final Set<Double> keys = result.subMap(letzterTeilAbschnitt.getWegBisher(), true, result.lastKey(), true)
          .keySet();
      for (final Double d : keys)
      {
        result.put(d, STATISCHE_SCHILDER.get(letzteGeschwindigkeitsBeschraenkung));
      }
    }
    return result;
  }

  /**
   * Konfiguiert die Y Achse fr die Anzahl der Fz pro Intervall.
   * 
   * @param neueAchse
   *          die Achse, welche die Einstellungen erhlt.
   */
  protected void konfiguriereYAxisAnzahlFz(final Axis neueAchse)
  {
    // Anzahl Fahrzeuge
    neueAchse.getTitle().getCaption().setValue(ANZAHL_FZ_INTERVALL);
    neueAchse.getTitle().getCaption().getFont().setRotation(90);
    neueAchse.getTitle().setVisible(true);

    bestimmeSkalen(neueAchse, streckenprofilModel.getChartProperties().getYAxisTypAnzahl());

  }

  /**
   * Erzeugt Hilfslinien fr eine Achse.
   * 
   * @param neueAchse
   *          die Achse, zu der Hilfslinien gemalt werden sollen.
   */
  private void erzeugeHilfslinien(final Axis neueAchse)
  {
    final LineAttributes lineAttributes = neueAchse.getMajorGrid().getLineAttributes();
    lineAttributes.setStyle(LineStyle.SOLID_LITERAL);
    lineAttributes.setColor(StreckenprofilUtil.createColorDefinition(new RGB(127, 127, 127)));
    neueAchse.getMajorGrid().setTickStyle(TickStyle.ACROSS_LITERAL);
    neueAchse.getMajorGrid().getTickAttributes().setColor(DARK_GREY.copyInstance());
    lineAttributes.setVisible(true);
    neueAchse.setType(AxisType.LINEAR_LITERAL);
  }

  /**
   * Bestimmt die Position und die Skalierung eines Achse.
   * 
   * @param neueAchse
   *          die neue Achse.
   * @param axisProps
   *          die {@link AchsenBeschreibung} der Achse.
   */
  protected void bestimmeSkalen(final Axis neueAchse, final AchsenBeschreibung axisProps)
  {
    final Position pos = axisProps.getAchsenposition();
    if (Position.RIGHT_LITERAL.equals(pos))
    {
      // Achse rechts
      neueAchse.setTitlePosition(Position.RIGHT_LITERAL);
      neueAchse.getOrigin().setType(IntersectionType.MAX_LITERAL);
      neueAchse.setLabelPosition(Position.RIGHT_LITERAL);
    }
    else
    {
      // Achse links
      neueAchse.setTitlePosition(Position.LEFT_LITERAL);
      neueAchse.getOrigin().setType(IntersectionType.MIN_LITERAL);
      neueAchse.setLabelPosition(Position.LEFT_LITERAL);
    }

    final boolean hasGridLinies = axisProps.isHilfslinien();
    if (hasGridLinies)
    {
      erzeugeHilfslinien(neueAchse);
    }
    final Scale scale = neueAchse.getScale();
    scale.setShowOutside(false);

    if (axisProps != null)
    {
      if (axisProps.getSchritte() > 0)
      {
        // scale.setStep((Math.max(axisProps.getMinimum(), axisProps
        // .getMaximum()) - Math.min(axisProps.getMinimum(),
        // axisProps.getMaximum()))
        // / axisProps.getSchritte());
        scale.setStep(axisProps.getSchritte());
      }

      scale.setMin(NumberDataElementImpl.create(Math.min(axisProps.getMinimum(), axisProps.getMaximum())));
      scale.setMax(NumberDataElementImpl.create(Math.max(axisProps.getMinimum(), axisProps.getMaximum())));
    }
  }

  /**
   * Konfiguriert die Y Achse Geschwindigkeit.
   * 
   * @param neueAchse
   *          die Achse, welche konfiguruert werden soll.
   */
  protected void konfiguriereYAxisGeschwindigkeit(final Axis neueAchse)
  {
    // Geschwindigkeit Fahrzeuge
    neueAchse.getTitle().getCaption().setValue(GESCHWINDIGKEIT_KM_H);
    neueAchse.getTitle().getCaption().getFont().setRotation(90);
    neueAchse.setAligned(true);
    neueAchse.setGapWidth(DEFAULT_GAP_WIDTH);
    neueAchse.getTitle().setVisible(true);
    bestimmeSkalen(neueAchse, streckenprofilModel.getChartProperties().getYAxisTypeGeschwindigkeit());
  }

  /**
   * Konfiguriert die Y Achse des LKW Anteils.
   * 
   * @param neueAchse
   *          die Achse, welche konfiguruert werden soll.
   */
  protected void konfiguriereYAxisLKWAnteil(final Axis neueAchse)
  {
    neueAchse.getTitle().getCaption().setValue(LKW_ANTEIL);
    neueAchse.getTitle().getCaption().getFont().setRotation(90);
    neueAchse.getTitle().setVisible(true);
    neueAchse.setAligned(true);
    neueAchse.setGapWidth(DEFAULT_GAP_WIDTH);
    bestimmeSkalen(neueAchse, streckenprofilModel.getChartProperties().getYAxisLKWAnteil());

  }

  /**
   * Konfiguriert die Y Achse der Fahrzeugdichte.
   * 
   * @param neueAchse
   *          die Achse, welche konfiguruert werden soll.
   */
  protected void konfiguriereYAxisFahrezeugdichte(final Axis neueAchse)
  {
    neueAchse.getTitle().getCaption().setValue(FAHRZEUGDICHTE_FZ_KM);
    neueAchse.getTitle().getCaption().getFont().setRotation(90);
    neueAchse.getTitle().setVisible(true);
    neueAchse.setAligned(true);
    neueAchse.setGapWidth(DEFAULT_GAP_WIDTH);
    bestimmeSkalen(neueAchse, streckenprofilModel.getChartProperties().getYAxisFahrezeugdichte());

  }

  /**
   * Konfiguriert die Y Achse der Bemessungsverkehrsstrke.
   * 
   * @param neueAchse
   *          die Achse, welche konfiguruert werden soll.
   */
  protected void konfiguriereYAxisBemessungsverkehrsstaerke(final Axis neueAchse)
  {
    neueAchse.getTitle().getCaption().setValue(BEMESSUNGSVERKEHRSSTAERKE_PKW_H);
    neueAchse.getTitle().getCaption().getFont().setRotation(90);
    neueAchse.getTitle().setVisible(true);
    neueAchse.setAligned(true);
    neueAchse.setGapWidth(DEFAULT_GAP_WIDTH);
    bestimmeSkalen(neueAchse, streckenprofilModel.getChartProperties().getYAxisBemessungsverkehrsstaerke());
  }

  /**
   * Konfiguriert die Y Achse Bemessungsverkehrsdichte.
   * 
   * @param neueAchse
   *          die Achse, welche konfiguruert werden soll.
   */
  protected void konfiguriereYAxisBemessungsverkehrsdichte(final Axis neueAchse)
  {
    neueAchse.getTitle().getCaption().setValue(BEMESSUNGSVERKEHRSDICHTE_PKW_KM);
    neueAchse.getTitle().getCaption().getFont().setRotation(90);
    neueAchse.getTitle().setVisible(true);
    neueAchse.setAligned(true);
    neueAchse.setGapWidth(DEFAULT_GAP_WIDTH);

    bestimmeSkalen(neueAchse, streckenprofilModel.getChartProperties().getYAxisBemessungsverkehrsdichte());
  }

  /**
   * Liefert das Chart-Objekt.
   * 
   * @return das BIRT {@link Chart} - Objekt.
   */
  public abstract Chart getChart();

  /**
   * Liefert den aktuellen Titel des Charts.
   * 
   * @return der Titel des Charts.
   */
  public abstract String getTitle();

  /**
   * Fgt/Aktualisiert eine Datenreihe des Charts.
   * 
   * @param lp
   *          die charakteristischen Linieneigenschaften.
   * @param daten
   *          die Datenreihe.
   */
  public abstract void setLineData(final LinienEigenschaften lp, final Map<SystemObjekt, OnlineDatum> daten);

  /**
   * Setzt die Datenreihen der Anzeigen.
   * 
   * @param anzeigeDaten
   *          Datenreihe der Anzeigen.
   */
  public void erzeugeDynamischeAnzeigen(final Map<AnzeigeQuerschnitt, Map<Anzeige, Daten>> anzeigeDaten)
  {

    if (!aqcache.isInitialisiert())
    {
      return;
    }

    if (verkehrsBeschreankungSchilderSeriesDefinition == null)
    {
      verkehrsBeschreankungSchilderSeriesDefinition = SeriesDefinitionImpl.create();

      schilderAchse = AxisImpl.create(Axis.ORTHOGONAL);
      schilderAchse.getLineAttributes().setVisible(false);
      schilderAchse.getLabel().setVisible(false);
      final Scale scale = schilderAchse.getScale();
      scale.setMin(NumberDataElementImpl.create(0));
      scale.setMax(NumberDataElementImpl.create(1));
      scale.setStepNumber(1);
      ((ChartWithAxes)getChart()).getPrimaryBaseAxes()[0].getAssociatedAxes().add(schilderAchse);
      schilderAchse.getSeriesDefinitions().add(verkehrsBeschreankungSchilderSeriesDefinition);
    }

    final Map<AttTlsWzgWvzCode, List<AnzeigeQuerschnitt>> tlsCodeMap = new HashMap<AttTlsWzgWvzCode, List<AnzeigeQuerschnitt>>();

    for (final AnzeigeQuerschnitt aq : anzeigeDaten.keySet())
    {
      final Map<Anzeige, OdAnzeigeEigenschaftIst.Daten> anzMap = anzeigeDaten.get(aq);
      for (final Anzeige anz : anzMap.keySet())
      {
        final OdAnzeigeEigenschaftIst.Daten datenAnzeigeEigenschaftIst = anzMap.get(anz);
        if (datenAnzeigeEigenschaftIst != null
            && OnlineDatum.Status.DATEN.equals(datenAnzeigeEigenschaftIst.dGetDatenStatus()))
        {
          final WvzInhalt inhalt = datenAnzeigeEigenschaftIst.getEigenschaft().getAnzeigeInhalt();
          final WvzInhaltUmsetzung umsetzung = aqcache.getWvzInhaltUmsetzung(inhalt);
          if (umsetzung instanceof WvzInhaltUmsetzungTls)
          {
            final WvzInhaltUmsetzungTls tls = (WvzInhaltUmsetzungTls)umsetzung;
            final KdWvzInhaltUmsetzungTls.Daten datenbWvzInhaltUmsetzungTls = tls.getKdWvzInhaltUmsetzungTls()
                .getDatum();
            final AttTlsWzgWvzCode code = datenbWvzInhaltUmsetzungTls.getCode();
            if (!tlsCodeMap.containsKey(code))
            {
              tlsCodeMap.put(code, new ArrayList<AnzeigeQuerschnitt>());
            }
            tlsCodeMap.get(code).add(aq);
          }

        }
      }

    }

    // Anzeigen lschen
    for (final AttTlsWzgWvzCode code : tlsCodeIconMap.keySet())
    {
      for (int i = 0; i < verkehrsBeschreankungSchilderSeriesDefinition.getSeries().size(); i++)
      {
        final Series alteSeries = verkehrsBeschreankungSchilderSeriesDefinition.getSeries().get(i);
        if (alteSeries.getSeriesIdentifier().equals(code.toString()))
        {
          verkehrsBeschreankungSchilderSeriesDefinition.getSeries().remove(i);
          break;
        }
      }
    }

    // Anzeigen anzeigen :)
    for (final AttTlsWzgWvzCode code : tlsCodeMap.keySet())
    {
      if (tlsCodeIconMap.get(code) == null)
      {
        continue;
      }

      final Double vertikalePosition = 1.0d;

      final List<AnzeigeQuerschnitt> staListe = tlsCodeMap.get(code);
      final Map<Double, Double> result = new TreeMap<Double, Double>();
      result.putAll(streckenprofilPositionenMap);

      for (final AnzeigeQuerschnitt sta : staListe)
      {
        result.put(sta.getWegBisher(), vertikalePosition);
      }

      final NumberDataSet orthoValuesDataSet1 = NumberDataSetImpl.create(result.values());
      final String seriesID = code.toString();
      final ScatterSeries ls = (ScatterSeries)ScatterSeriesImpl.create();
      ls.setSeriesIdentifier(seriesID);
      ls.setSeriesIdentifier(code.toString());

      ls.setDataSet(orthoValuesDataSet1);

      for (int i = 0; i < ls.getMarkers().size(); i++)
      {
        ls.getMarkers().get(i).setType(MarkerType.ICON_LITERAL);
        ls.getMarkers().get(i).setSize(12);
        ls.getMarkers().get(i).setFill(tlsCodeIconMap.get(code).copyInstance());
      }

      verkehrsBeschreankungSchilderSeriesDefinition.getSeries().add(ls);
    }

  }

  /**
   * Liefert das momentan verwendete Streckenprofil.
   * 
   * @return the model
   */
  public final Modell getModel()
  {
    return streckenprofilModel;
  }

  /**
   * Speicher wieder freigeben.
   */
  public void dispose()
  {
  }

  /**
   * Liefert eine {@link Map} mit allen Positionen (als {@link Double}) die innerhalb des Streckenprofils relevant sind,
   * mit dem dazugehrigen default Wert.
   * 
   * @return the streckenprofilPositionenMap
   */
  public final TreeMap<Double, Double> getStreckenprofilPositionenMap()
  {
    return streckenprofilPositionenMap;
  }

  /**
   * Setzt die Sichtbarkeit der bergebenen {@link Axis}.
   * 
   * @param achse
   *          die {@link Axis}
   * @param visible
   *          <code>true</code>, wenn die Achse sichtbar sein soll, sonst <code>false</code>
   */
  protected void setSichtbarkeitAchse(final Axis achse, final boolean visible)
  {
    if (achse != null)
    {
      achse.getLineAttributes().setVisible(visible);
      achse.getTitle().setVisible(visible);
      achse.getMajorGrid().getTickAttributes().setVisible(visible);
      if (visible)
      {
        achse.getLabel().getCaption().getFont().setSize(DEFAULT_AXIS_LABEL_TEXT_SIZE);
        achse.getLabel().getCaption().setColor(ColorDefinitionImpl.BLACK());
      }
      else
      {
        achse.getLabel().getCaption().getFont().setSize(0);
        achse.getLabel().getCaption().setColor(ColorDefinitionImpl.WHITE());
      }
    }
  }

  /**
   * Setzt die Sichtbarkeit aller {@link Axis}.
   * 
   * @param visible
   *          <code>true</code>, wenn die Achsen sichtbar sein sollen, sonst <code>false</code>
   */
  public abstract void setAlleAchsenSichtbarkeit(final boolean visible);

}
