/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/* Segment 13 Bedienung und Visualisierung, Plug-In Streckenprofil 
 * Copyright (C) 2009-2010 BitCtrl Systems GmbH
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information: 
 * BitCtrl Systems GmbH 
 * Weienfelser Strae 67 
 * 04229 Leipzig 
 * Phone: +49 341-490670 
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.pages;

import net.sf.paperclips.BigPrint;
import net.sf.paperclips.ImagePrint;
import net.sf.paperclips.PagePrint;
import net.sf.paperclips.ScalePrint;
import net.sf.paperclips.SeriesPrint;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.util.EContentAdapter;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.viewers.CellLabelProvider;
import org.eclipse.jface.viewers.ViewerCell;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.ControlListener;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.printing.Printer;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.widgets.Form;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

import com.bitctrl.lib.eclipse.actions.ToggleVisibleComponentsAction;
import com.bitctrl.lib.eclipse.birt.chart.ChartCanvas;
import com.bitctrl.lib.eclipse.birt.chart.print.BirtChartPrint;
import com.bitctrl.util.ITwoDimensionalMap;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Activator;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Modell;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.StreckenprofilCanvas;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.actions.ExportGridAction;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.chart.StreckenprofilLegendeChartBuilder;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.IChartUpdateListener;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.StreckenprofilChartComposite;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.StreckenprofilEditor;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.StreckenprofilLegendeComposite;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.StreckenprofilYAxisLeftChartComposite;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.StreckenprofilYAxisRightChartComposite;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.export.MatrixGrid;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.export.MatrixGridPrint;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.export.StreckenprofilMatrixGridFactoryHelper;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.LinienEigenschaften;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenprofilPackage;
import de.bsvrz.buv.rw.basislib.legende.ILegendenAbschnitt;
import de.bsvrz.buv.rw.bitctrl.eclipse.legende.ICustomLegende;
import de.bsvrz.buv.rw.bitctrl.eclipse.legende.ILegende;
import de.bsvrz.sys.funclib.bitctrl.modell.OnlineDatum;
import de.bsvrz.sys.funclib.bitctrl.modell.SystemObjekt;
import de.bsvrz.sys.funclib.bitctrl.modell.tmvewsimulationglobal.objekte.OfflineSimulation;

/**
 * {@link org.eclipse.ui.forms.editor.FormPage} in der das Erweiterte
 * Streckenprofil angezeigt wird.
 * 
 * @author BitCtrl Systems GmbH, Hoesel
 * @version $Id: StreckenprofilEditorStreckenProfil.java,v 1.5 2014/05/13 13:21:56 Pittner Exp $
 */
public class StreckenprofilEditorStreckenProfil extends
		AbstractStreckenProfilEditorFormPage implements IChartUpdateListener {

	/**
	 * Implementierung der Schnittstellen zur Befllen einer Legende.
	 * 
	 * @author BitCtrl Systems GmbH, Hoesel
	 * @version $Id: StreckenprofilEditorStreckenProfil.java,v 1.5 2014/05/13 13:21:56 Pittner Exp $
	 */
	private class Legende implements ILegendenAbschnitt, ICustomLegende {
		@Override
		public String getTitel() {
			return "Streckenprofil";
		}

		@Override
		public String getId() {
			return legendeID;
		}

		@Override
		public void erzeugeAbschnittsInhalt(final Composite flaeche) {

			int legendenHoehe = modell.getLineProperties().size()
					* LEGENDEN_EINTRAG_HOEHE;
			if (modell.getChartProperties().isAnzeigeQuerschnitteIcons()) {
				legendenHoehe += LEGENDEN_EINTRAG_HOEHE;
			}
			if (modell.getChartProperties().isGeschwindigkeitsLimitIcons()) {
				legendenHoehe += LEGENDEN_EINTRAG_HOEHE;
			}
			if (modell.getChartProperties().isGeschwindigkeitsLimitLinieStat()) {
				legendenHoehe += LEGENDEN_EINTRAG_HOEHE;
			}
			if (modell.getChartProperties().isGeschwindigkeitsLimitLinieDyn()) {
			  legendenHoehe += LEGENDEN_EINTRAG_HOEHE;
			}

			final ScrolledComposite scroll = new ScrolledComposite(flaeche,
					SWT.V_SCROLL | SWT.H_SCROLL);
			scroll.setExpandHorizontal(true);
			scroll.setExpandVertical(true);
			scroll.setLayout(new FillLayout());

			streckenprofilLegendeComposite = new StreckenprofilLegendeComposite(
					scroll, SWT.DOUBLE_BUFFERED);
			streckenprofilLegendeComposite.setStreckenEditorModell(modell);

			scroll.setMinSize(streckenprofilLegendeComposite.computeSize(
					SWT.DEFAULT, legendenHoehe));
			scroll.setContent(streckenprofilLegendeComposite);

			modell.getEMFModell().eAdapters().add(new EContentAdapter() {

				/*
				 * (non-Javadoc)
				 * 
				 * @see org.eclipse.emf.ecore.util.EContentAdapter
				 * #notifyChanged (org.eclipse.emf.common.notify.Notification)
				 */
				@Override
				public void notifyChanged(

				final Notification notification) {
					super.notifyChanged(notification);
					final Object feature = notification.getFeature();
					if (StreckenprofilPackage.Literals.STRECKENPROFIL_EDITOR_MODEL__LINE_PROPERTIES
							.equals(feature)
							|| StreckenprofilPackage.Literals.DIAGRAMM_EIGENSCHAFTEN__ANZEIGE_QUERSCHNITTE_ICONS
									.equals(feature)
							|| StreckenprofilPackage.Literals.DIAGRAMM_EIGENSCHAFTEN__GESCHWINDIGKEITS_LIMIT_ICONS
									.equals(feature)
							|| StreckenprofilPackage.Literals.DIAGRAMM_EIGENSCHAFTEN__GESCHWINDIGKEITS_LIMIT_LINIE_STAT
									.equals(feature) 
					  || StreckenprofilPackage.Literals.DIAGRAMM_EIGENSCHAFTEN__GESCHWINDIGKEITS_LIMIT_LINIE_DYN
					  .equals(feature)) 
					{
						if (flaeche != null && !flaeche.isDisposed()) {

							streckenprofilLegendeComposite
									.setStreckenEditorModell(modell);
							int legendenHoehe = modell.getLineProperties()
									.size() * LEGENDEN_EINTRAG_HOEHE;
							if (modell.getChartProperties()
									.isAnzeigeQuerschnitteIcons()) {
								legendenHoehe += LEGENDEN_EINTRAG_HOEHE;
							}
							if (modell.getChartProperties()
									.isGeschwindigkeitsLimitIcons()) {
								legendenHoehe += LEGENDEN_EINTRAG_HOEHE;
							}
							if (modell.getChartProperties()
									.isGeschwindigkeitsLimitLinieStat()) {
								legendenHoehe += LEGENDEN_EINTRAG_HOEHE;
							}
							if (modell.getChartProperties()
							    .isGeschwindigkeitsLimitLinieDyn()) {
							  legendenHoehe += LEGENDEN_EINTRAG_HOEHE;
							}

							scroll.setContent(streckenprofilLegendeComposite);
							scroll.setMinSize(streckenprofilLegendeComposite
									.computeSize(150, legendenHoehe));
							scroll.layout(true);
						}
					}
				}
			});

		}

		@Override
		public void createControl(final Composite parent) {
			erzeugeAbschnittsInhalt(parent);
		}

		@Override
		public Control getControl() {
			if (isActive()) {
				return getManagedForm().getForm().getForm().getBody();
			} else {
				return null;
			}
		}
	}

	/**
	 * Default-Hhe eines Eintrags in der Legende in Pixeln.
	 */
	private static final int LEGENDEN_EINTRAG_HOEHE = 28;

	/**
	 * Das {@link Composite}, in dem das erweiterte Streckenprofil gemalt wird.
	 */
	private StreckenprofilChartComposite streckenprofilChartComposite;

	/**
	 * Tabelle der Verkehrsdaten.
	 */
	private MatrixGrid<SystemObjekt, LinienEigenschaften, OnlineDatum> matrix;

	/**
	 * Das Streckenprofil.
	 */
	private final Modell modell;

	/**
	 * Composite, das nur eine Legende enthlt und die Legende des Rahmenwerks
	 * bedient.
	 */
	private StreckenprofilLegendeComposite streckenprofilLegendeComposite;

	/**
	 * Aktion zum exportieren der aktuellen Verkehrsdaten.
	 */
	private ExportGridAction exportDataAction;

	/**
	 * Der Prfix fr die ID, die der Rahmenwerkslegende bermittelt wird.
	 */
	private String legendeID = "ID_LEGENDE_STRECKENPROFIL";

	/**
	 * {@link Section}, in der das BIRT - Chart gemalt wird.
	 */
	private Section chartSection;

	/**
	 * Das {@link Composite} auf der linken Seite, zum Anzeigen der Y-Achsen.
	 */
	private StreckenprofilYAxisLeftChartComposite linkeYAchseComposite;

	/**
	 * Container, in den das Chart eingepackt wird.
	 */
	private ScrolledComposite streckenprofilChartContainerComposite;

	/**
	 * Konstruktor zur Erzeugung einer
	 * {@link org.eclipse.ui.forms.editor.FormPage} zur Anzeige des Erweiterten
	 * Streckenprofils.
	 * 
	 * @param editor
	 *            der Multipage - Editor, zu dem das
	 *            {@link StreckenprofilEditorStreckenProfil} gehrt.
	 * @param modell
	 *            das Modell des Streckenprofils.
	 */
	public StreckenprofilEditorStreckenProfil(
			final StreckenprofilEditor editor, final Modell modell) {
		super(editor, StreckenprofilEditorStreckenProfil.class.getName(),
				"Streckenprofil");
		this.modell = modell;
		legendeID += "_" + System.currentTimeMillis();
	}

	@Override
	protected void createFormContent(final IManagedForm managedForm) {
		super.createFormContent(managedForm);
		final ScrolledForm form = managedForm.getForm();
		form.setText(getTitle());
		final Composite formBody = form.getForm().getBody();
		formBody.setLayout(new FormLayout());
		final FormToolkit toolkit = managedForm.getToolkit();
		final SashForm sash = new SashForm(formBody, SWT.HORIZONTAL);
		final FormData fd = new FormData();
		fd.top = new FormAttachment(0, 10);
		fd.bottom = new FormAttachment(100, -10);
		fd.left = new FormAttachment(0, 10);
		fd.right = new FormAttachment(100, -10);
		sash.setLayoutData(fd);
		sash.setLayout(new FormLayout());
		createFesteYAchseLinksSection(sash, toolkit);
		createDiagramSection(sash, toolkit);
		createFesteYAchseRechtsSection(sash, toolkit);
		sash.setWeights(new int[] { 15, 85, 15 });
		// Online-Hilfe hinzufgen
		PlatformUI
				.getWorkbench()
				.getHelpSystem()
				.setHelp(
						getManagedForm().getForm(),
						Activator.PLUGIN_ID
								+ "."
								+ StreckenprofilEditorStreckenProfil.class
										.getSimpleName());
	}

	/**
	 * Erzeugt die {@link Section} fr die Y-Achsen auf der rechten Seite des
	 * Diagramms.
	 * 
	 * @param formBody
	 *            das parent Objekt.
	 * @param toolkit
	 *            das {@link FormToolkit}.
	 */
	private void createFesteYAchseRechtsSection(final Composite formBody,
			final FormToolkit toolkit) {
		final Section flyingAxisSection = toolkit.createSection(formBody,
				defaultSectionStyle);
		flyingAxisSection.setText("Y-Achsen");
		final Composite diagramClient = toolkit.createComposite(
				flyingAxisSection, SWT.NONE);
		toolkit.paintBordersFor(diagramClient);

		flyingAxisSection.setClient(diagramClient);
		diagramClient.setLayout(new FormLayout());
		// nur zur Ermittlung der Hoehe einer Scrollbar
		final ScrolledComposite scroll = new ScrolledComposite(diagramClient,
				SWT.H_SCROLL);
		final int hoehe = scroll.getHorizontalBar().getSize().y;
		scroll.dispose();
		final StreckenprofilYAxisRightChartComposite comp = new StreckenprofilYAxisRightChartComposite(
				diagramClient, SWT.NONE);
		final FormData fd = new FormData();
		fd.top = new FormAttachment(0, 10);
		fd.bottom = new FormAttachment(100, -hoehe);
		fd.left = new FormAttachment(0, 10);
		fd.right = new FormAttachment(100, 0);
		comp.setLayoutData(fd);
		comp.setStreckenEditorModell(modell);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.forms.editor.FormPage#setFocus()
	 */
	@Override
	public void setFocus() {
		getManagedForm().getForm().setFocus();
	}

	/**
	 * Erzeugt die {@link Section} fr die Y-Achsen auf der linken Seite des
	 * Diagramms.
	 * 
	 * @param formBody
	 *            das parent Objekt.
	 * @param toolkit
	 *            das {@link FormToolkit}.
	 */
	private void createFesteYAchseLinksSection(final Composite formBody,
			final FormToolkit toolkit) {
		final Section flyingAxisSection = toolkit.createSection(formBody,
				defaultSectionStyle);
		flyingAxisSection.setText("Y-Achsen");
		final Composite diagramClient = toolkit.createComposite(
				flyingAxisSection, SWT.NONE);
		toolkit.paintBordersFor(diagramClient);

		flyingAxisSection.setClient(diagramClient);
		diagramClient.setLayout(new FormLayout());
		// nur zur Ermittlung der Hoehe einer Scrollbar
		final ScrolledComposite scroll = new ScrolledComposite(diagramClient,
				SWT.H_SCROLL);
		final int hoehe = scroll.getHorizontalBar().getSize().y;
		scroll.dispose();
		linkeYAchseComposite = new StreckenprofilYAxisLeftChartComposite(
				diagramClient, SWT.NONE);

		final FormData fd = new FormData();
		fd.top = new FormAttachment(0, 10);
		fd.bottom = new FormAttachment(100, -hoehe);
		fd.left = new FormAttachment(0, 10);
		fd.right = new FormAttachment(100, 0);
		linkeYAchseComposite.setLayoutData(fd);
		linkeYAchseComposite.setStreckenEditorModell(modell);

		flyingAxisSection.addControlListener(new ControlAdapter() {

			@Override
			public void controlResized(final ControlEvent e) {
				linkeYAchseComposite.getChartCanvas().repaintChart();
				linkeYAchseComposite.pack(true);
			}

		});

	}

	/**
	 * Erzeugt eine {@link Section}, in der das Erweiterte Streckenprofil gemalt
	 * werden soll.
	 * 
	 * @param formBody
	 *            das Parent Composite.
	 * @param toolkit
	 *            Das Toolkit.
	 */
	private void createDiagramSection(final Composite formBody,
			final FormToolkit toolkit) {

		chartSection = toolkit.createSection(formBody, defaultSectionStyle);
		final FormData fd = new FormData();
		fd.top = new FormAttachment(0, 10);
		fd.bottom = new FormAttachment(100, -10);
		fd.left = new FormAttachment(0, 10);
		fd.right = new FormAttachment(100, -10);
		chartSection.setLayoutData(fd);

		chartSection.setText("Diagramm");
		final Composite diagramClient = toolkit.createComposite(chartSection,
				SWT.NONE);
		toolkit.paintBordersFor(diagramClient);
		chartSection.setClient(diagramClient);

		diagramClient.setLayout(new GridLayout());

		streckenprofilChartContainerComposite = new ScrolledComposite(
				diagramClient, SWT.H_SCROLL | SWT.V_SCROLL);
		streckenprofilChartContainerComposite.setLayoutData(new GridData(
				SWT.FILL, SWT.FILL, true, true));
		streckenprofilChartContainerComposite.setLayout(new FillLayout());

		streckenprofilChartComposite = new StreckenprofilChartComposite(
				streckenprofilChartContainerComposite, SWT.DOUBLE_BUFFERED);
		streckenprofilChartComposite.setStreckenEditorModell(modell);

		streckenprofilChartContainerComposite.setExpandHorizontal(true);
		streckenprofilChartContainerComposite.setExpandVertical(true);
		streckenprofilChartContainerComposite
				.setContent(streckenprofilChartComposite);

		// diagramClient.addControlListener(new ControlListener() {
		//
		// @Override
		// public void controlResized(final ControlEvent e) {
		// getManagedForm().getForm().setMinWidth(
		// streckenprofilChartComposite.getSize().x);
		// streckenprofilChartComposite.pack(true);
		// }
		//
		// @Override
		// public void controlMoved(final ControlEvent e) {
		// getManagedForm().getForm().setMinWidth(
		// streckenprofilChartComposite.getSize().x);
		// streckenprofilChartComposite.pack(true);
		// }
		// });
		streckenprofilChartContainerComposite
				.addControlListener(new ControlAdapter() {

					@Override
					public void controlResized(final ControlEvent e) {
						layoutModified();

					}

					/*
					 * (non-Javadoc)
					 * 
					 * @see
					 * org.eclipse.swt.events.ControlAdapter#controlMoved(org
					 * .eclipse.swt.events.ControlEvent)
					 */
					@Override
					public void controlMoved(final ControlEvent e) {
						layoutModified();
					}

				});

		streckenprofilChartComposite
				.addUpdateListener(new IChartUpdateListener() {

					@Override
					public void datensatzAktualisiert(
							final ITwoDimensionalMap<SystemObjekt, LinienEigenschaften, OnlineDatum> valueMap) {
						layoutModified();
					}
				});
		streckenprofilChartContainerComposite.setBackground(Display
				.getDefault().getSystemColor(SWT.COLOR_WHITE));

		setSimulation(((StreckenprofilEditor) getEditor())
				.getAktuelleSimulation());

		final Form form = getManagedForm().getForm().getForm();
		toolkit.decorateFormHeading(form);
		matrix = new MatrixGrid<SystemObjekt, LinienEigenschaften, OnlineDatum>(
				diagramClient, SWT.V_SCROLL | SWT.H_SCROLL | SWT.BORDER,
				new StreckenprofilMatrixGridFactoryHelper());
		matrix.getControl().setLayoutData(
				new GridData(SWT.FILL, SWT.FILL, true, true));
		matrix.getGrid().setCellSelectionEnabled(true);
		matrix.setRowHeaderLabelProvider(new CellLabelProvider() {

			@Override
			public void update(final ViewerCell cell) {
				final Object element = cell.getElement();
				if (element instanceof LinienEigenschaften) {
					cell.setText(((LinienEigenschaften) element)
							.getTypDatenQuelle().getLiteral()
							+ "-"
							+ ((LinienEigenschaften) element)
									.getTypVerkehrsDaten().getLiteral());
				} else if (element instanceof SystemObjekt) {

					cell.setText(((SystemObjekt) element).getName());

				} else {
					cell.setText(element.toString());
				}
			}
		});

		matrix.getGrid().setLayoutData(
				new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		matrix.setInput(streckenprofilChartComposite.getGridMap());
		streckenprofilChartComposite.addUpdateListener(this);

		final IToolBarManager toolBarManager = form.getToolBarManager();

		exportDataAction = new ExportGridAction(matrix.getGrid());
		toolBarManager.add(exportDataAction);

		final Action toggleGridVisibilityAction = new ToggleVisibleComponentsAction(
				getManagedForm().getForm(),
				streckenprofilChartContainerComposite, null,
				matrix.getControl());
		toggleGridVisibilityAction
				.setToolTipText("Umschalten zwischen Diagramm und Tabellenansicht");
		toolBarManager.add(toggleGridVisibilityAction);

		getManagedForm().getForm().addControlListener(new ControlListener() {

			@Override
			public void controlResized(final ControlEvent e) {
				layoutModified();
			}

			@Override
			public void controlMoved(final ControlEvent e) {
				layoutModified();

			}
		});

		// final ToggleLegendeAction legendeOeffnen = new ToggleLegendeAction(
		// getEditor());
		// toolBarManager.add(legendeOeffnen);
		toolBarManager.update(true);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.forms.editor.FormPage#dispose()
	 */
	@Override
	public void dispose() {
		if (streckenprofilChartComposite != null) {
			streckenprofilChartComposite.dispose();
		}
		super.dispose();
	}

	@Override
	public void datensatzAktualisiert(
			final ITwoDimensionalMap<SystemObjekt, LinienEigenschaften, OnlineDatum> valueMap) {
		if (matrix != null) {
			matrix.setInput(valueMap);
			exportDataAction.setTitleText(streckenprofilChartComposite
					.getTitle());
		}
		chartSection.setText(streckenprofilChartComposite.getTitle());
		chartSection.layout();
	}

	/**
	 * Exportiert die aktuell im Erweiteren Streckenprofil angezeigten
	 * Verkehrsdaten.
	 */
	public void streckenprofilDatenExportieren() {
		if (exportDataAction != null) {
			exportDataAction.run();
		}
	}

	/**
	 * Neuberechnung des Layouts, damit nur das Chart selbst Scrollbars
	 * zeichnet.
	 */
	private void layoutModified() {
		if (streckenprofilChartComposite != null
				&& !streckenprofilChartComposite.isDisposed()) {
			streckenprofilChartComposite.setSize(
					StreckenprofilCanvas.MIN_BREITE,
					StreckenprofilCanvas.MIN_HOEHE);
			streckenprofilChartContainerComposite
					.setMinSize(streckenprofilChartComposite.getSize());
			streckenprofilChartContainerComposite.getHorizontalBar()
					.setVisible(true);
			streckenprofilChartContainerComposite.layout(true, true);

			getManagedForm().getForm().setMinSize(getPartControl().getSize());
			// streckenprofilChartContainerComposite.pack(true);
		}
	}

	@Override
	public void setSimulation(final OfflineSimulation simulation) {
		if (streckenprofilChartComposite != null) {
			streckenprofilChartComposite.setSimulation(simulation);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.part.WorkbenchPart#getAdapter(java.lang.Class)
	 */
	@SuppressWarnings("unchecked")
	@Override
	public Object getAdapter(final Class adapter) {
		if (ILegende.class.equals(adapter)) {
			return this;
		} else if (ILegendenAbschnitt.class.equals(adapter)) {
			return new Legende();
		} else {
			return super.getAdapter(adapter);
		}
	}

	@Override
	public PagePrint getDruckAuftrag() {
		final SeriesPrint col = new SeriesPrint();

		// Tabelle
		col.add(new BigPrint(
				new ScalePrint(
						new MatrixGridPrint<SystemObjekt, LinienEigenschaften, OnlineDatum>(
								matrix))));

		// Legende
		final StreckenprofilLegendeChartBuilder builder = new StreckenprofilLegendeChartBuilder(
				modell);
		for (final LinienEigenschaften lp : modell.getLineProperties()) {
			builder.setLineData(lp, null);
		}
		builder.getChart().getBlock().getBounds().setWidth(400);

		int anzahlLegendenEintraege = modell.getLineProperties().size();
		if (modell.getChartProperties().isAnzeigeQuerschnitteIcons()) {
			anzahlLegendenEintraege++;
		}
		if (modell.getChartProperties().isGeschwindigkeitsLimitIcons()) {
			anzahlLegendenEintraege++;
		}
		if (modell.getChartProperties().isGeschwindigkeitsLimitLinieStat()) {
			anzahlLegendenEintraege++;
		}
		if (modell.getChartProperties().isGeschwindigkeitsLimitLinieDyn()) {
		  anzahlLegendenEintraege++;
		}

		builder.getChart()
				.getBlock()
				.getBounds()
				.setHeight(
						Math.max(anzahlLegendenEintraege
								* LEGENDEN_EINTRAG_HOEHE, 50));

		col.add(new BigPrint(new ScalePrint(new BirtChartPrint(builder
				.getChart()))));

		streckenprofilChartComposite.setAlleAchsenSichtbarkeit(true);
		final ChartCanvas canvas = streckenprofilChartComposite
				.getChartCanvas();
		canvas.regenerateChart();

		// Chart
		final Printer p = new Printer();
		final Image img = new Image(p, canvas.getBounds());
		final GC gc = new GC(img);
		canvas.print(gc);
		gc.dispose();

		streckenprofilChartComposite.setAlleAchsenSichtbarkeit(false);
		canvas.regenerateChart();

		final ImageData imgData = img.getImageData();
		img.dispose();
		col.add(new BigPrint(new ScalePrint(new ImagePrint(imgData))));
		return new PagePrint(col);

	}

	@Override
	public String getTitel() {
		return streckenprofilChartComposite.getTitle();
	}

}
