/*
 * Created on Jul 13, 2004
 */
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.type;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Represents our allowable data types - a small subset of those available in a real database!
 * 
 * @author Pittner
 * 
 */
public class StreckenProfilElementTyp
{

  private static List typen = new ArrayList();

  // TODO staBes: #1 Erweiterung um die zwei Typen der statischen Beschilderung.
  public static StreckenProfilElementTyp WZG_A_STATISCH = new StreckenProfilElementTyp("WZG-A-Statisch");
  public static StreckenProfilElementTyp WZG_A_STATISCH_UV = new StreckenProfilElementTyp("WZG-A-Statisch-UV");
  
  public static StreckenProfilElementTyp UFD_HELLIGKEIT = new StreckenProfilElementTyp("Helligkeit");
  public static StreckenProfilElementTyp UFD_OBERFLAECHE = new StreckenProfilElementTyp("Oberflaeche");
  public static StreckenProfilElementTyp UFD_NIEDERSCHLAG = new StreckenProfilElementTyp("Niederschlag");
  public static StreckenProfilElementTyp UFD_SICHTWEITE = new StreckenProfilElementTyp("Sichtweite");

  public static StreckenProfilElementTyp WZG_A = new StreckenProfilElementTyp("WZG-A");
  public static StreckenProfilElementTyp WZG_A2 = new StreckenProfilElementTyp("WZG-A2");
  public static StreckenProfilElementTyp WZG_A_GESCHW = new StreckenProfilElementTyp("WZG-A-GESCHW");
  public static StreckenProfilElementTyp WZG_A_DWISTA = new StreckenProfilElementTyp("WZG-A-DWISTA");
  public static StreckenProfilElementTyp WZG_B = new StreckenProfilElementTyp("WZG-B");
  public static StreckenProfilElementTyp WZG_B_DWISTA = new StreckenProfilElementTyp("WZG-B-DWISTA");
  public static StreckenProfilElementTyp WZG_C = new StreckenProfilElementTyp("WZG-C");
  public static StreckenProfilElementTyp WZG_C2 = new StreckenProfilElementTyp("WZG-C2");
  public static StreckenProfilElementTyp WZG_BLINKER = new StreckenProfilElementTyp("Blinker");
   
  public static StreckenProfilElementTyp FREITEXT = new StreckenProfilElementTyp("Freitext"); 
  public static StreckenProfilElementTyp WZG_BLINKER_B = new StreckenProfilElementTyp("Blinker-WZG-B");
  
  // TODO quers: #9 Der neue Elementtp fr die Anzeige der AQ-, MQ- und UQ-Texte
  public static StreckenProfilElementTyp STANDORT_QUERSCHNITT = new StreckenProfilElementTyp("Standort-Querschnitt");
  
  private String typ;

  private StreckenProfilElementTyp(String type)
  {
    this.typ = type;
    String typeToAdd = this.getType();
    typen.add(typeToAdd);
  }

  /**
   * @return Returns the type.
   */
  public String getType()
  {
    return typ;
  }

  public static boolean hasType(String type)
  {
    return typen.contains(type.toUpperCase());
  }

  public static String getTypes()
  {
    StringBuffer typeBuffer = new StringBuffer();
    for (Iterator iter = typen.iterator(); iter.hasNext();)
    {
      String element = (String)iter.next();
      typeBuffer.append(element).append(", ");
    }
    if (typen.size() >= 1)
    {
      typeBuffer.delete(typeBuffer.length() - 2, typeBuffer.length());
    }
    return typeBuffer.toString();
  }
}