package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.aufhebungen.aufhebung;

import java.util.Vector;

import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.WVZInhalt;
import de.bsvrz.sba.plugin.parameter.steuerungskern.dialog.AnzeigeInhaltTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.VerwaltungWvzInhalte;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.AnzeigeElementTyp;

public class DefaultWerte
{
  /**
   * Methode liefert die Defaultregeln fr die Aufhebung fr einen WZG Typ
   * @param wzgTyp WZG Typ 
   */
  public Vector<RegelAufhebungNeu> getDefaultWerte (AnzeigeElementTyp wzgTyp)
  {
		Vector<RegelAufhebungNeu> regeln = new Vector<RegelAufhebungNeu>();
		
		if (wzgTyp == AnzeigeElementTyp.WZG_A)
			return getDefaultWerteTypA();

		if (wzgTyp == AnzeigeElementTyp.WZG_B)
			return getDefaultWerteTypB();

		return regeln;
  }
		
  /**
   * Methode liefert die Defaultregeln fr die Aufhebung fr WZG Typ B
   * @return Defaultregeln
   */
  public Vector<RegelAufhebungNeu> getDefaultWerteTypB ()
  {
		Vector<RegelAufhebungNeu> regeln = new Vector<RegelAufhebungNeu>();

    VerwaltungWvzInhalte verw = VerwaltungWvzInhalte.getInstance();

		WVZInhalt uevPkw  = verw.getWvzInhalt (AnzeigeElementTyp.WZG_B, AnzeigeInhaltTyp.TLS_UEBERHOLVERBOT_ALLGEMEIN);
		WVZInhalt uevLkw  = verw.getWvzInhalt (AnzeigeElementTyp.WZG_B, AnzeigeInhaltTyp.TLS_UEBERHOLVERBOT_LKW);
		
		WVZInhalt endeUevPkw  = verw.getWvzInhalt (AnzeigeElementTyp.WZG_B, AnzeigeInhaltTyp.TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN); 
		WVZInhalt endeUevLkw  = verw.getWvzInhalt (AnzeigeElementTyp.WZG_B, AnzeigeInhaltTyp.TLS_ENDE_UEBERHOLVERBOT_LKW);
		
		Aspect schaltgrund = VerwaltungParaAufhebung.getInstance().getSchaltgrundAllgemein();
		
		long t1 = 0;
		long t2 = 60 * 1000;
		
		WVZInhalt [][] aufhebungen = new WVZInhalt [][]
    {
			{ uevPkw,  endeUevPkw },
			{ uevLkw,  endeUevLkw },
    };

		for (WVZInhalt [] aufhebung : aufhebungen)
		{
		  regeln.add(new RegelAufhebungNeu(schaltgrund, aufhebung [0], aufhebung [1], t1, t2 ));	
		}
		
		return regeln;
  }
		
  /**
   * Methode liefert die Defaultregeln fr die Aufhebung fr WZG Typ A
   * @return Defaultregeln
   */
  public Vector<RegelAufhebungNeu> getDefaultWerteTypA ()
  {
		Vector<RegelAufhebungNeu> regeln = new Vector<RegelAufhebungNeu>();

    VerwaltungWvzInhalte verw = VerwaltungWvzInhalte.getInstance();

    WVZInhalt anfang [] = new WVZInhalt []
    {                                         
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_40),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_50),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_60),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_80),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_100),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_120),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_130),
    };

    WVZInhalt ende [] = new WVZInhalt []
    {                                       
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_40),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_50),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_60),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_80),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_100),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_120),
		  verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_130),
    };

		Aspect schaltgrund = VerwaltungParaAufhebung.getInstance().getSchaltgrundAllgemein();
		
		long t1 = 0;
		long t2 = 60 * 1000;

		// Prfen welche Geschwindigkeiten tatschlich versorgt sind
		
		int anzahl = 0;
		for (int i=0; i<anfang.length; ++i)
			if ((anfang [i] != null) && (ende [i] != null))
			  anzahl++;
		
		WVZInhalt [][] aufhebungen = new WVZInhalt [anzahl][2];

		int j = 0;
		for (int i=0; i<anfang.length; ++i)
		{
			if ((anfang [i] != null) && (ende [i] != null))
			{
				aufhebungen [j][0] = anfang [i];
				aufhebungen [j][1] = ende   [i];
				
				j++;
			}
		}
		
		for (WVZInhalt [] aufhebung : aufhebungen)
		{
		  regeln.add(new RegelAufhebungNeu(schaltgrund, aufhebung [0], aufhebung [1], t1, t2 ));	
		}
		
		return regeln;
  }
}
