package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.entfernungsangaben;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import java.util.Vector;

import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.parameter.steuerungskern.Activator;
import de.bsvrz.sba.plugin.parameter.steuerungskern.dialog.DialogNeueTreppenFunktion;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.Konfig;
import de.bsvrz.sys.funclib.debug.Debug;
import de.koelnloevenich.dif.basislib.urlasserdialog.UrlasserDialog;

/**
 * View ermglicht die Auswahl von Treppenfunktionen
 * @author ObertM
 *
 */
public class ViewAuswahlTreppenFunktion extends ViewPart
{
  public static String ID = "de.bsvrz.sba.plugin.parameter.steuerungskern.verwaltung.view.allgemein.ViewAuswahlTreppenFunktion";

  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();
  
  /**
   * Parent Compisite
   */
  private Composite _parent;
  
  /**
   * Oberes Composite
   */
  private Composite compositeTop;

  private Group _gruppeUebersicht;

  private Table _tabelleKmdPar;

  private TableViewer _tableViewerKmdPar;

  private ISelectionChangedListener _selectionChangedListener;

  private Composite compositeBottom;

  private Button buttonOk;

  private Button buttonAbbrechen;

//  private int _numViewInstances = 0;

  private ClientDavInterface _connection;

  private Button buttonHilfe;

  protected List<SystemObject> m_angewaehlteObjekte;

	private String _secondViewId;

	private List<String> _treppenFunktionen;

	private Button _buttonLoeschen;

  public List<SystemObject> getAngewaehlteObjekte()
  {
    return m_angewaehlteObjekte;
  }

  @Override
  public void createPartControl(Composite parent)
  {
    _parent = parent;

    String name = "Auswahl Treppenfunktion";
    
    if (_secondViewId != null)
    	name += " " + _secondViewId;
    
    this.setPartName(name);

    PlatformUI.getWorkbench().getHelpSystem().setHelp( _parent, Activator.PLUGIN_ID + ".auswahl" );

    _parent.setLayout(new GridLayout());
    
    createCompositeTop(_parent);
    createCompositeInstanzen(_parent);
    createCompositeBottom(_parent);
    
    _connection = DaVVerbindung.getInstanz().getDaVVerbindung();

    /*
     * Die bisher versorgten Treppenfunktionen bestimmen
     */
    
    Vector<TreppenFunktion> treppenFunktionen = VerwaltungParaEntfernungsAngaben.getInstance().getTreppenFunktionen();
    
    Map<String, TreppenFunktion> treeMap = new TreeMap<String, TreppenFunktion>();
    for (TreppenFunktion tf : treppenFunktionen)
    {
      treeMap.put(tf.getBezeichnung(), tf);
    }

    List<String> sortList = new ArrayList<String>();
    sortList.addAll(treeMap.keySet());

//    System.out.println(sortList.size());
    
    _treppenFunktionen = sortList;
    _tableViewerKmdPar.setInput(sortList);

  }

  @Override
  public void setFocus()
  {
    if (_parent != null)
      _parent.setFocus();

  }

  /**
   * Erzeugt gruppeUebersicht
   * 
   */
  private void createCompositeTop(Composite parent)
  {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessVerticalSpace = true;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.FILL;
    compositeTop = new Composite(parent, SWT.NONE);
    compositeTop.setLayout(new GridLayout());
    compositeTop.setLayoutData(gridData);
    GridData gridDataTabelle = new GridData();
    gridDataTabelle.horizontalAlignment = GridData.FILL;
    gridDataTabelle.grabExcessHorizontalSpace = true;
    gridDataTabelle.grabExcessVerticalSpace = true;
    gridDataTabelle.verticalAlignment = GridData.FILL;
    GridData gridDataGruppeUebersicht = new GridData();
    gridDataGruppeUebersicht.horizontalAlignment = GridData.FILL;
    gridDataGruppeUebersicht.grabExcessHorizontalSpace = true;
    gridDataGruppeUebersicht.grabExcessVerticalSpace = true;
    gridDataGruppeUebersicht.verticalAlignment = GridData.FILL;
    _gruppeUebersicht = new Group(compositeTop, SWT.NONE);
    _gruppeUebersicht.setLayout(new GridLayout());
    _gruppeUebersicht.setLayoutData(gridDataGruppeUebersicht);
    _gruppeUebersicht.setText("Auswahl Treppenfunktionen:");
    _tabelleKmdPar = new Table(_gruppeUebersicht, SWT.BORDER | SWT.MULTI | SWT.FULL_SELECTION);
    _tabelleKmdPar.setHeaderVisible(true);
    _tabelleKmdPar.setLayoutData(gridDataTabelle);
    _tabelleKmdPar.setLinesVisible(true);
    _tableViewerKmdPar = new TableViewer(_tabelleKmdPar);
    // _tableViewerKmdPar = new CheckboxTableViewer(_tabelleKmdPar);

    TableColumn tcKey = new TableColumn(_tabelleKmdPar, SWT.LEFT);
    tcKey.setText("Treppenfunktion:");
    tcKey.setWidth(250);

    _tableViewerKmdPar.setContentProvider(new ContentProvider());
    _tableViewerKmdPar.setLabelProvider(new LabelProvider());

    _selectionChangedListener = new ISelectionChangedListener() 
    {
      public void selectionChanged(SelectionChangedEvent event)
      {
        IStructuredSelection selection = (IStructuredSelection)event.getSelection();
        
        _buttonLoeschen.setEnabled(!selection.isEmpty());

        Object firstElement = selection.getFirstElement();
        if (firstElement instanceof String)
        {
        }
      }

    };
    _tableViewerKmdPar.addSelectionChangedListener(_selectionChangedListener);
    _tableViewerKmdPar.addDoubleClickListener(new IDoubleClickListener() {

      @Override
      public void doubleClick(DoubleClickEvent event)
      {
        openViewParameterSteuerungsKern();       
      }
    });
  }
  
  /**
   * Methode liefert die angewhlten Objekte zurck
   * @return angewhlte Objekte
   */
  private List<SystemObject> bestimmeAngewaehlteObjekte ()
  {
    List<SystemObject> listKBA = new ArrayList<SystemObject>();
    
    IStructuredSelection selection = (IStructuredSelection)_tableViewerKmdPar.getSelection();
    
    Object firstElement = selection.getFirstElement();
    if (firstElement instanceof SystemObject)
    {      
      Object[] array = selection.toArray();
      for (Object object : array)
      {
        SystemObject so = (SystemObject)object;
        listKBA.add(so);          
      }
    }
    
    return listKBA;
  }
  
  private void openViewParameterSteuerungsKern ()
  {
    IStructuredSelection selection = (IStructuredSelection)_tableViewerKmdPar.getSelection();
    
    Object firstElement = selection.getFirstElement();
    if (firstElement instanceof String)
    {      
      Object[] array = selection.toArray();
      List<String> listKBA = new ArrayList<String>();
       
      for (Object object : array)
      {
        String so = (String)object;
        listKBA.add(so);          
      }
      
      IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
      IWorkbenchPage page = dw.getActivePage();
      
      if (listKBA.size() > 0)
      {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < listKBA.size(); i++)
        {
          String so = listKBA.get(i);
          if (i<listKBA.size()-1)
            sb.append(so + ";");
          else
            sb.append(so);
        }

        OpenViewParameterEntfernungsAngaben.openView (sb.toString());
      }        
    }
  }

  private void createCompositeBottom(Composite parent)
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.END;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    compositeBottom = new Composite(parent, SWT.NONE);
    compositeBottom.setLayoutData(gridData3);
    compositeBottom.setLayout(rowLayout);
    buttonOk = new Button(compositeBottom, SWT.NONE);
    buttonOk.setText("Ok");
    buttonOk.addMouseListener(new MouseAdapter() {


      @Override
      public void mouseDown(MouseEvent e)
      {
         openViewParameterSteuerungsKern();      
      }
    });

    buttonAbbrechen = new Button(compositeBottom, SWT.NONE);
    buttonAbbrechen.setText("Abbrechen");
    buttonAbbrechen.addMouseListener(new MouseAdapter() {

      @Override
      public void mouseDown(MouseEvent e)
      {
        super.mouseDown(e);
        aktionAbbrechen();
      }

    });
    
    buttonHilfe = new Button(compositeBottom, SWT.NONE);
    buttonHilfe.setText("Hilfe");
    buttonHilfe.addMouseListener(new MouseAdapter() {

      @Override
      public void mouseDown(MouseEvent e)
      {
        super.mouseDown(e);
        aktionHilfe();
      }

    });
  }

  private void createCompositeInstanzen(Composite parent)
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.END;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    compositeBottom = new Composite(parent, SWT.NONE);
    compositeBottom.setLayoutData(gridData3);
    compositeBottom.setLayout(rowLayout);
    
    Button buttonNeu = new Button(compositeBottom, SWT.NONE);
    buttonNeu.setText("Neue Treppenfunktion anlegen");
    buttonNeu.addMouseListener(new MouseAdapter() 
    {
      @Override
      public void mouseDown(MouseEvent e)
      {
        aktionNeueTreppenFunktion ();
      }
    });

    _buttonLoeschen = new Button(compositeBottom, SWT.NONE);
    _buttonLoeschen.setText("Treppenfunktion lschen");
    _buttonLoeschen.setEnabled(false);
    _buttonLoeschen.addMouseListener(new MouseAdapter() 
    {
      @Override
      public void mouseDown(MouseEvent e)
      {
        aktionLoescheTreppenFunktion ();
      }
    });
  }

  /**
   * Methode lscht eine Treppenfunktion
   */
  protected void aktionLoescheTreppenFunktion()
  {
    IStructuredSelection selection = (IStructuredSelection)_tableViewerKmdPar.getSelection();
    
    Object firstElement = selection.getFirstElement();
    if (firstElement instanceof String)
    {
    	String nameTreppenFunktion = (String) firstElement;
    	
	  	if (loescheParameterInDaV(nameTreppenFunktion))
	  	{
	  		_treppenFunktionen.remove(nameTreppenFunktion);
	      _tableViewerKmdPar.setInput(_treppenFunktionen);
	      _tableViewerKmdPar.getTable().layout(true);
	  	}
    }
  }

	/**
   * Methode legt eine neue Treppenfunktion an
   */
  protected void aktionNeueTreppenFunktion()
  {
    Shell parentShell = createSShell();

	  DialogNeueTreppenFunktion dialog = new DialogNeueTreppenFunktion (parentShell);
	  String nameTreppenFunktion = dialog.open();
	  
	  if (nameTreppenFunktion != null)
	  {
	  	if (speichernDerParameterInDaV(nameTreppenFunktion))
	  	{
	  		_treppenFunktionen.add(nameTreppenFunktion);
	      _tableViewerKmdPar.setInput(_treppenFunktionen);
	      _tableViewerKmdPar.getTable().layout(true);
	  	}
	  }
  }
  

  /**
   * This method initializes sShell
   */
  private static Shell createSShell()
  {
    Shell shell = new Shell();
    shell.setText("Shell");
    shell.setSize(new Point(300, 200));
    shell.setLayout(new GridLayout());
    return shell;
  }

  /**
   * Methode legt einen Defaultparametersatz fr eine neue Treppenfunktion im DaV an
   * @return Inormation ob Datenstze angelegt werden konnten
   */
  private Boolean speichernDerParameterInDaV(String nameTreppenFunktion)
  {   
  	Boolean schliessenOk = false;
  	
  	/*
  	 * Daten der einzelnen Tabs einlesen
  	 */

    TreppenFunktion treppenFunktion = new TreppenFunktion(nameTreppenFunktion);
    
    VerwaltungParaEntfernungsAngaben.getInstance().addTreppenFunktion(treppenFunktion);

    /*
	   * Attributgruppe zusammenstellen und an den DaV senden
	   */

    List<ResultData> list = new ArrayList<ResultData>();
    
	  Data data = VerwaltungParaEntfernungsAngaben.getInstance().getData();
    if (data != null)
    {
      SystemObject sysObj = _connection.getDataModel().getObject(Konfig.getInstance().getPidSBA());
      AttributeGroup atg  = _connection.getDataModel().getAttributeGroup ("atg.sswSbaEntfernungsAngaben");
      Aspect asp = _connection.getDataModel().getAspect("asp.parameterVorgabe");
      DataDescription dd = new DataDescription(atg, asp);

      ResultData result = new ResultData( sysObj, dd, new Date ().getTime(), data );
      list.add(result);
    }

    if (list.size() > 0)
    {
      UrlasserDialog urlasserDialog = new UrlasserDialog( Display.getCurrent().getActiveShell() );
      schliessenOk = (urlasserDialog.anzeigen( list )).getEingabeOk();
    }

    return schliessenOk;
  }

  /**
   * Methode lscht die Parameterstze fr eine neue Instanz im DaV
   * @return Information ob Aktion erfolgreich war
   */
  private Boolean loescheParameterInDaV(String bezeichnung)
  {   
  	Boolean schliessenOk = false;
  	
    /*
     * Parameter auf die einzelnen Parameterarten verteilen
     */
    
    VerwaltungParaEntfernungsAngaben.getInstance().removeTreppenFunktion(bezeichnung);

	  /*
	   * Attributgruppe zusammenstellen und an den DaV senden
	   */

    List<ResultData> list = new ArrayList<ResultData>();

	  Data data = VerwaltungParaEntfernungsAngaben.getInstance().getData();
    if (data != null)
    {
      SystemObject sysObj = _connection.getDataModel().getObject(Konfig.getInstance().getPidSBA());
      AttributeGroup atg  = _connection.getDataModel().getAttributeGroup ("atg.sswSbaEntfernungsAngaben");
      Aspect asp = _connection.getDataModel().getAspect("asp.parameterVorgabe");
      DataDescription dd = new DataDescription(atg, asp);

      ResultData result = new ResultData( sysObj, dd, new Date ().getTime(), data );
      list.add(result);
    }

    if (list.size() > 0)
    {
      UrlasserDialog urlasserDialog = new UrlasserDialog( Display.getCurrent().getActiveShell() );
      schliessenOk = (urlasserDialog.anzeigen( list )).getEingabeOk();
    }

    return schliessenOk;
  }

  
	protected void aktionAbbrechen()
  {
    PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().hideView(this);
  }

  /**
   * Zeigt die Hilfe zum Dialog an.
   * 
   */
  protected void aktionHilfe()
  {
    String contextId = Activator.PLUGIN_ID + ".auswahl";
    _debug.fine("ContextID: " + contextId);
    
    PlatformUI.getWorkbench().getHelpSystem().displayHelp(contextId);
  }

  private class ContentProvider implements IStructuredContentProvider
  {
    @Override
    public Object[] getElements(Object inputElement)
    {
      List list = (List)inputElement;

      Object[] re = new Object[list.size()];

      for (int i = 0; i < list.size(); i++)
      {
        re[i] = list.get(i);
      }
      return re;
    }

    @Override
    public void dispose()
    {
    }

    @Override
    public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
    {
    }

  }

  private class LabelProvider implements ITableLabelProvider
  {

    @Override
    public Image getColumnImage(Object element, int columnIndex)
    {
      return null;
    }

    @Override
    public String getColumnText(Object element, int columnIndex)
    {

      // String[] ss = (String[])element;

      String returnString = null;

      switch (columnIndex)
      {
        case 0:
          returnString = (String)element;
          break;

        default:
          returnString = "default";
      }

      return returnString;

    }

    @Override
    public void addListener(ILabelProviderListener listener)
    {
    }

    @Override
    public void dispose()
    {
    }

    @Override
    public boolean isLabelProperty(Object element, String property)
    {
      return false;
    }

    @Override
    public void removeListener(ILabelProviderListener listener)
    {
    }

  }

  @Override
  public void init( IViewSite site, IMemento memento ) throws PartInitException
  {
    _secondViewId = site.getSecondaryId();
    super.init( site, memento );
  }

}
