package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.monotonieKreuzPfeil;

import java.util.Observable;
import java.util.Observer;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Spinner;

/**
 * Tabellen Modell fr die Parameter "Monotonie Kreuz/Pfeil"
 * @author ObertM
 *
 */
public class TableModel extends Observable implements Observer
{
	/**
	 * Merker zum Lschen der Zeile
	 */
	private Composite _loeschen;
	
	/**
	 * Schaltgrund
	 */
  private Composite _schaltgrund;
  
  /**
   * Arbeitsrichtung
   */
  private Composite _richtungLaengs;

  /**
   * Arbeitsrichtung
   */
  private Composite _richtungQuer;

  /**
   * Parameter X
   */
  private Composite _x;

  /**
   * Parameter Y
   */
  private Composite _y;
  
  /**
   * Parameter Z
   */
  private Composite _z;
  
  /**
   * Konstruktor der Klasse 
   * @param loeschen Lschen
   * @param schaltgrund Schaltgrund der Regel
   * @param richtung Arbeitsrichtung
   * @param x zu prfender Anzeigeinhalt
   * @param xyz Anzeigeinhalt des Vorgngers/Nachfolgers
   * @param uvw Anzeigeinhalt des Vorgngers des Vorgngers / Nachfolger des Nachfolgers
   * @param a zu schaltender Anzeigeinhalt
   */
  public TableModel(Composite loeschen, Composite schaltgrund, Composite richtungLaengs, Composite richtungQuer, Composite x, Composite y, Composite z)
  {
  	this._loeschen = loeschen;
    this._schaltgrund = schaltgrund;
    this._richtungLaengs = richtungLaengs;   
    this._richtungQuer = richtungQuer;   
    this._x = x;    
    this._y = y;    
    this._z = z;    
  }

  /**
   * Methode liefert den eingestellten Wert des Composite Lschen
   * @return eingestellter Wert
   */
  public String getSelectedLoeschen()
  {
    return getSelectedWert(_loeschen);    
  }

  /**
   * Methode liefert den eingestellten Wert des Composite Schaltgrund
   * @return eingestellter Wert
   */
  public String getSelectedSchaltgrund ()
  {
    return getSelectedWert(_schaltgrund);    
  }

  /**
   * Methode liefert den eingestellten Wert des Composite RichtungLaengs
   * @return eingestellter Wert
   */
  public String getSelectedRichtungLaengs ()
  {
    return getSelectedWert(_richtungLaengs);    
  }

  /**
   * Methode liefert den eingestellten Wert des Composite RichtungQuer
   * @return eingestellter Wert
   */
  public String getSelectedRichtungQuer ()
  {
    return getSelectedWert(_richtungQuer);    
  }

  /**
   * Methode liefert die eingestellten Werte des Composite X
   * @return eingestellte Werte
   */
  public String[] getSelectedX ()
  {
  	Control[] controls = _x.getChildren();
  	String [] selected = new String [controls.length];
  	
  	for (int i=0; i<controls.length; ++i)
  	  selected [i] = getSelectedWert(controls [i]);
  	
    return selected;    
  }

  /**
   * Methode liefert die eingestellten Werte des Composite Y
   * @return eingestellte Werte
   */
  public String[] getSelectedY ()
  {
  	Control[] controls = _y.getChildren();
  	String [] selected = new String [controls.length];
  	
  	for (int i=0; i<controls.length; ++i)
  	  selected [i] = getSelectedWert(controls [i]);
  	
    return selected;    
  }

  /**
   * Methode liefert die eingestellten Werte des Composite Z
   * @return eingestellte Werte
   */
  public String[] getSelectedZ ()
  {
  	Control[] controls = _z.getChildren();
  	String [] selected = new String [controls.length];
  	
  	for (int i=0; i<controls.length; ++i)
  	  selected [i] = getSelectedWert(controls [i]);
  	
    return selected;    
  }

  /**
   * Methode setzt den Wert des Compiste Lschen
   * @param selWert zu setzender Wert
   */
  public void setSelectedLoeschen(String selWert)
  {
    setSelectedWert(_loeschen, selWert, null);
  }

  /**
   * Methode setzt den Wert des Compiste Lschen
   * @param selWert zu setzender Wert
   */
  public void setSelectedSchaltgrund(String selWert)
  {
    setSelectedWert(_schaltgrund, selWert, null);
  }

  /**
   * Methode setzt den Wert des Compiste RichtungLaengs
   * @param selWert zu setzender Wert
   */
  public void setSelectedRichtungLaengs(String selWert)
  {
    setSelectedWert(_richtungLaengs, selWert, null);
  }

  /**
   * Methode setzt den Wert des Compiste RichtungQuer
   * @param selWert zu setzender Wert
   */
  public void setSelectedRichtungQuer(String selWert)
  {
    setSelectedWert(_richtungQuer, selWert, null);
  }

  /**
   * Methode setzt die Werte des Compiste X
   * @param selWert zu setzender Wert
   */
  public void setSelectedX (Image[] selImage)
  {
  	Control[] controls = _x.getChildren();
  	
  	for (int i=0; i<controls.length; ++i)
  	  setSelectedWert (controls [i], null, selImage [i]);
  }

  /**
   * Methode setzt die Werte des Compiste Y
   * @param selWert zu setzender Wert
   */
  public void setSelectedY (Image[] selImage)
  {
  	Control[] controls = _y.getChildren();
  	
  	for (int i=0; i<controls.length; ++i)
  	  setSelectedWert (controls [i], null, selImage [i]);
  }

  /**
   * Methode setzt die Werte des Compiste Z
   * @param selWert zu setzender Wert
   */
  public void setSelectedZ (Image[] selImage)
  {
  	Control[] controls = _z.getChildren();
  	
  	for (int i=0; i<controls.length; ++i)
  	  setSelectedWert (controls [i], null, selImage [i]);
  }

  /**
   * Methode liefert den eingestellten Wert des ersten Control Elements eines Composite
   * als String zurck.
   * @param c Composite
   * @return Wert als String
   */
  public String getSelectedWert(Composite c)
  {
  	Control control = c.getChildren()[0];

  	return getSelectedWert(control);
  }

  /**
   * Methode liefert den eingestellten Wert eines Control Elements 
   * als String zurck.
   * @param control Control Element
   * @return Wert als String
   */
  public String getSelectedWert(Control control)
  {
    if ( control instanceof Spinner )
    {
      Spinner sp = (Spinner)control;
      int spSel = sp.getSelection();
      return String.valueOf(spSel);
    }
    else if ( control instanceof Combo )
    {
      Combo cb = (Combo)control;
      String cbSel = cb.getItem( cb.getSelectionIndex() );
      return cbSel;
    }
    else if ( control instanceof Button )
    {
      if ( (control.getStyle() & SWT.CHECK) != 0 )
      {
        Button ch = (Button)control;
        boolean chSel = ch.getSelection();
        return String.valueOf(chSel);
      }
      else
        return "";
    }
    else if ( control instanceof Label )
    {
      Label im = (Label)control;
      String imSel = (String)im.getData();
      return imSel;
    }
    else
      return "";
  }

  /**
   * Methode setzt den Wert des ersten Control Elements eines Composite
   * @param c Composite
   */
  public void setSelectedWert(Composite c, String selWert, Image selImage)
  {
    Control control = c.getChildren()[0];

    setSelectedWert(control, selWert, selImage);
  }

  /**
   * Methode setzt den Wert eines Control Elements eines Composite
   * @param c Composite
   */
  public void setSelectedWert(Control control, String selWert, Image selImage)
  {
    if ( control instanceof Spinner )
    {
      Spinner sp = (Spinner)control;
      try
      {
        sp.setSelection(Integer.valueOf( selWert ));
      }
      catch (NumberFormatException e)
      {
        e.printStackTrace();
      }
    }
    else if ( control instanceof Combo )
    {
      Combo cb = (Combo)control;
      for (int k = 0; k < cb.getItemCount(); k++)
      {
        if (selWert.equals(cb.getItem( k )))
          cb.select(k);      
      }
    }
    else if ( control instanceof Button )
    {
      if ( (control.getStyle() & SWT.CHECK) != 0 )
      {
        Button ch = (Button)control;
        ch.setSelection( Boolean.valueOf( selWert ) );
      }
    }
    else if ( control instanceof Label )
    {
        Label im = (Label)control;
        im.setData( selWert );
        im.setImage( selImage ); 
    }
  }

  @Override
  public void update(Observable o, Object arg)
  {
    fireEvent();
  }

  public void fireEvent()
  {
    setChanged();
    notifyObservers();
  }

	/**
   * Methode liefert loeschen zurck
   * @return loeschen
   */
  public Composite getLoeschen()
  {
  	return _loeschen;
  }

	/**
   * Methode setzt die Variable loeschen
   * @param loeschen zu bernehmender Wert fr loeschen
   */
  public void setLoeschen(Composite loeschen)
  {
  	_loeschen = loeschen;
  }

	/**
   * Methode liefert schaltgrund zurck
   * @return schaltgrund
   */
  public Composite getSchaltgrund()
  {
  	return _schaltgrund;
  }

	/**
   * Methode setzt die Variable schaltgrund
   * @param schaltgrund zu bernehmender Wert fr schaltgrund
   */
  public void setSchaltgrund(Composite schaltgrund)
  {
  	_schaltgrund = schaltgrund;
  }

	/**
   * Methode liefert richtungLaengs zurck
   * @return richtungLaengs
   */
  public Composite getRichtungLaengs()
  {
  	return _richtungLaengs;
  }

	/**
   * Methode setzt die Variable richtungLaengs
   * @param richtung zu bernehmender Wert fr richtungLaengs
   */
  public void setRichtungLaengs(Composite richtung)
  {
  	_richtungLaengs = richtung;
  }

	/**
   * Methode liefert richtungQuer zurck
   * @return richtungLaengs
   */
  public Composite getRichtungQuer()
  {
  	return _richtungQuer;
  }

	/**
   * Methode setzt die Variable richtungQuer
   * @param richtung zu bernehmender Wert fr richtungQuer
   */
  public void setRichtungQuer(Composite richtung)
  {
  	_richtungQuer = richtung;
  }

	/**
   * Methode liefert x zurck
   * @return x
   */
  public Composite getX()
  {
  	return _x;
  }

	/**
   * Methode setzt die Variable x
   * @param x zu bernehmender Wert fr x
   */
  public void setX(Composite x)
  {
  	_x = x;
  }

	/**
   * Methode liefert y zurck
   * @return y
   */
  public Composite getY()
  {
  	return _y;
  }

	/**
   * Methode setzt die Variable y
   * @param y zu bernehmender Wert fr y
   */
  public void setY(Composite y)
  {
  	_y = y;
  }

	/**
   * Methode liefert z zurck
   * @return z
   */
  public Composite getZ()
  {
  	return _z;
  }

	/**
   * Methode setzt die Variable z
   * @param z zu bernehmender Wert fr z
   */
  public void setZ (Composite z)
  {
  	_z = z;
  }
}
