package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.notwendigeschaltungen.absolutnotwendigeschaltung;

import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.config.Aspect;

/**
 * Klasse enthlt eine Regel fr die Regelklasse "Absolut Notwendige Schaltung", 
 * Regel "Ausschaltregel".<br> 
 * @author Swarco Traffic Systems GmbH
 * @author Matthias Obert
 */
public class RegelAbsolutNotwendigeSchaltung
{
  /**
   * Regelspezifischer Schaltgrund
   */
  private Aspect m_schaltgrundRegel;
  
  /**
   * Soll Regel angewendet werden
   */
  private boolean m_regelAnwenden;
  
  /**
   * Methode zum Auswerten einer Regel der Attributliste 'atl.sswSbaRegelNotwendigeSchaltung'
   * @param data Daten vom DaV
   */
  public void auswerteAttributgruppe (Data data, Aspect schaltgrundAllgemein)
  {
    m_schaltgrundRegel = (Aspect) data.getReferenceValue( "SchaltgrundRegel" ).getSystemObject();
    
    if (m_schaltgrundRegel == null)
      m_schaltgrundRegel = schaltgrundAllgemein;

    String jaNein = data.getItem( "RegelAnwenden" ).asTextValue().getText();
    m_regelAnwenden = jaNein.equalsIgnoreCase( "Ja" );
  }

  /**
   * Methode liefert den Inhalt der Klasse als String
   */
  public String toString ()
  {
    String s = "";

    s += "Anwenden = " + m_regelAnwenden + "\n";
    return s;
  }

  /**
   * Methode liefert die Variable m_schaltgrundRegel zurck
   * @return Variable m_schaltgrundRegel
   */
  public Aspect getSchaltgrundRegel()
  {
    return m_schaltgrundRegel;
  }

  /**
   * Methode setzt die Variable m_schaltgrundRegel
   * @param schaltgrundRegel Wert auf den die Variable m_schaltgrundRegel gesetzt werden soll
   */
  public void setSchaltgrundRegel( Aspect schaltgrundRegel )
  {
    m_schaltgrundRegel = schaltgrundRegel;
  }

  /**
   * Methode liefert die Variable m_regelAnwenden zurck
   * @return Variable m_regelAnwenden
   */
  public boolean isRegelAnwenden()
  {
    return m_regelAnwenden;
  }

  /**
   * Methode setzt die Variable m_regelAnwenden
   * @param regelAnwenden Wert auf den die Variable m_regelAnwenden gesetzt werden soll
   */
  public void setRegelAnwenden( boolean regelAnwenden )
  {
    m_regelAnwenden = regelAnwenden;
  }
}
