package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.AnzeigeElementTyp;

public class CompositeABlinkerBC extends Composite
{
	public CompositeABlinkerBC(Composite parent, int style)
  {
	  super(parent, style);
	  
	  this.setBackground(parent.getBackground());
	  
    createComposite();
  }

  /**
   * Methode initialisiert das Composite
   */
  private void createComposite ()
  {
    GridData gd = new GridData();
    gd.horizontalAlignment = GridData.CENTER;
    gd.verticalAlignment = GridData.CENTER;
    gd.grabExcessHorizontalSpace = true;
    gd.grabExcessVerticalSpace = true;

    Composite composite = this;
	  
	  composite.setBackgroundMode( SWT.INHERIT_DEFAULT );
	  composite.setLayoutData( gd );
	  composite.setLayout( new GridLayout(1, false) );

	  /*
	   * ... A
	   */
	  new BildAuswahl ( composite, SWT.CENTER | SWT.BORDER, AnzeigeElementTyp.WZG_A);
	  
	  /*
	   * ... Blinker
	   */
	  new BildAuswahl ( composite, SWT.CENTER | SWT.BORDER, AnzeigeElementTyp.BLINKER);

	  /*
	   * ... B Gert
	   */
	  new BildAuswahl ( composite, SWT.CENTER | SWT.BORDER, AnzeigeElementTyp.WZG_B);
	
	  /*
	   * ... C Gert
	   */
	  new BildAuswahl ( composite, SWT.CENTER | SWT.BORDER, AnzeigeElementTyp.WZG_C);
  }

	public Control getA()
  {
	  return getChildren()[0];
  }

	public Control getBlinker()
  {
	  return getChildren()[1];
  }

	public Control getB()
  {
	  return getChildren()[2];
  }

	public Control getC()
  {
	  return getChildren()[3];
  }
}
