/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.sba.plugin.parametereditor.editor;

import java.util.LinkedList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import de.bsvrz.buv.rw.basislib.datenidentifikation.DatenidentifikationGtm;
import de.bsvrz.buv.rw.basislib.datenidentifikation.GtmListeComposite;
import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.config.SystemObjectType;
import de.bsvrz.sba.plugin.actions.parameter.DefaultParameterIds;
import de.bsvrz.sba.plugin.actions.parameter.IParameter;
import de.bsvrz.sba.plugin.actions.parameter.verwaltung.ParameterActionRegistry;
import de.bsvrz.sba.plugin.actions.parameter.verwaltung.ParameterActionRegistryElement;

public class ViewEditorTest extends ViewPart
{

	public static final String ID = "de.bsvrz.sba.plugin.test.editor.ViewEditorTest";
	private Composite top = null;

	private Button buttonKapselTest = null;
	private Button buttonDatIdent = null;
	private Button chkboxEditable = null;

	@Override
	public void createPartControl(Composite parent)
	{
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		top = new Composite(parent, SWT.NONE);
		top.setLayout(gridLayout);

		buttonKapselTest = new Button(top, SWT.NONE);
		buttonKapselTest.setText("Kapsel Test");
		buttonKapselTest
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter()
				{
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e)
					{
//						aktionKapsel();
						aktionKapselParameterActionRegistry();
					}
				});

		buttonDatIdent = new Button(top, SWT.NONE);
		buttonDatIdent.setText("Daten Identifikation");
		buttonDatIdent
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter()
				{
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e)
					{
						// DatenidentifikationNeu id = new DatenidentifikationNeu(PlatformUI
						// .getWorkbench().getDisplay().getActiveShell(), DaVVerbindung
						// .getInstanz().getDaVVerbindung());
						// id.oeffne(Darstellung.OBJEKTELISTE_OBJEKTTYP);

						DatenidentifikationGtm dia = new DatenidentifikationGtm(PlatformUI
								.getWorkbench().getDisplay().getActiveShell(), null);
						// dia.oeffnen(CompositeGtmListe._darstlungSystemObjekteObjektTypen);

						SystemObjectType type = DaVVerbindung.getInstanz()
								.getDaVVerbindung().getDataModel().getType("typ.fahrStreifen");
						LinkedList<SystemObjectType> types = new LinkedList<SystemObjectType>();
						types.add(type);

						dia.oeffnen(types, GtmListeComposite._darstlungSystemObjekte);

					}
				});

		
		chkboxEditable = new Button(top, SWT.CHECK);
		chkboxEditable.setSelection(true);
		chkboxEditable.setText("Editierbar");
	}

	private void aktionKapsel()
	{
		String pidSysObj = "ske.Fussballspiel";
		String pidAtg = "atg.systemKalenderEintrag";
		String pidAspEmpfang = "asp.parameterSoll";
		String pidAspSenden = "asp.parameterVorgabe";
		short simVar = 0;
		ParameterEditorKapsel kapsel = new ParameterEditorKapsel(pidSysObj, pidAtg,
				pidAspEmpfang, pidAspSenden, simVar);

		String pidSysObj2 = "ske.Messe";
		ParameterEditorKapsel kapsel2 = new ParameterEditorKapsel(pidSysObj2,
				pidAtg, pidAspEmpfang, pidAspSenden, simVar);

		LinkedList<ParameterEditorKapsel> kapselListe = new LinkedList<ParameterEditorKapsel>();
		kapselListe.add(kapsel);
		kapselListe.add(kapsel2);

		
		String pidSysObjArray = "ereignis.Fussballspiel";
		String pidAtgArray = "atg.ereignisParameter";
		String pidAspEmpfangArray = "asp.parameterSoll";
		String pidAspSendenArray = "asp.parameterVorgabe";
		short simVarArray = 0;
		ParameterEditorKapsel kapselArray = new ParameterEditorKapsel(
				pidSysObjArray, pidAtgArray, pidAspEmpfangArray, pidAspSendenArray,
				simVarArray);
		kapselListe.add(kapselArray);

		OpenViewParameterEditor.openView(kapselListe, true, true);
		
		if(chkboxEditable != null)
		{
			if(chkboxEditable.getSelection())
			{
				OpenViewParameterEditor.openView(kapselListe, true, true);
			}
			else
			{
				OpenViewParameterEditor.openView(kapselListe, true, false);
			}
		}
		else
		{
			OpenViewParameterEditor.openView(kapselListe, true, true);
		}
		

	}

	private void aktionKapselParameterActionRegistry()
	{
		ParameterActionRegistryElement first = ParameterActionRegistry
				.getInstance()
				.getParameterActionElements("NAVIGATORID_PARAMETEREDITOR").getFirst();

		if (first != null)
		{
			LinkedList<String> parameterIds = first.getParameterAction()
					.getParameterIds();

			if ((parameterIds.contains(DefaultParameterIds.pidSystemObjects))
					&& (parameterIds.contains(DefaultParameterIds.pidAtg))
					&& (parameterIds.contains(DefaultParameterIds.pidAspEmpfang))
					&& (parameterIds.contains(DefaultParameterIds.pidAspSenden))
					&& (parameterIds.contains(DefaultParameterIds.simVar)))
			{

				LinkedList<IParameter> parameters = new LinkedList<IParameter>();

//				String pidSysObj = "ske.Fussballspiel,ske.Messe,ereignis.Fussballspiel";
				String pidSysObj = "ske.Fussballspiel,ske.Messe";
				String pidAtg = "atg.systemKalenderEintrag";
				String pidAspEmpfang = "asp.parameterSoll";
				String pidAspSenden = "asp.parameterVorgabe";
				short simVar = 0;

				Parameter pPidsSysObj = new Parameter(
						DefaultParameterIds.pidSystemObjects, pidSysObj, pidSysObj);
				Parameter pPidAtg = new Parameter(DefaultParameterIds.pidAtg, pidAtg,
						pidAtg);
				Parameter pAspEmpfang = new Parameter(
						DefaultParameterIds.pidAspEmpfang, pidAspEmpfang, pidAspEmpfang);
				Parameter pAspSenden = new Parameter(DefaultParameterIds.pidAspSenden,
						pidAspSenden, pidAspSenden);
				Parameter pSimVar = new Parameter(DefaultParameterIds.simVar, ""
						+ simVar, "" + simVar);
				
				parameters.add(pPidsSysObj);
				parameters.add(pPidAtg);
				parameters.add(pAspEmpfang);
				parameters.add(pAspSenden);
				parameters.add(pSimVar);
				
				first.getParameterAction().runParameterAction(parameters);
			}

		}

	}

	/**
	 * Implementierung von {@link IParameter}
	 * @author HofmannJ
	 *
	 */
	private class Parameter implements IParameter
	{
		private String _id = null;
		private Object _value = null;
		private String _info = null;

		public Parameter(String id, Object value, String info)
		{
			this._id = id;
			this._value = value;
			this._info = info;
		}

		@Override
		public String getId()
		{
			return _id;
		}

		@Override
		public String getParameterInfo()
		{
			return _info;
		}

		@Override
		public Object getValue()
		{
			return _value;
		}

		@Override
		public void setValue(Object value)
		{
			this._value = value;
		}

	}

	@Override
	public void setFocus()
	{
	}

}
