package de.bsvrz.sba.plugin.zlt.dav;

import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.config.SystemObject;

/**
 * Abstrakte Basis-Klasse fr Klassen zur Darstellung der Daten aus einer ATG.
 * 
 * @author Swarco Traffic Systems GmbH
 * 
 */
public abstract class AbstractAtgData
{
	private SystemObject _so;

	public abstract void initFromResult(ResultData result);

	public AbstractAtgData(SystemObject so) {
		setSo(so);
	}

	public AbstractAtgData() {

	}

	public SystemObject getSo()
	{
		return _so;
	}

	public void setSo(SystemObject so)
	{
		_so = so;
	}

	@Override
	public String toString()
	{
		return "AbstractAtgData [_so=" + _so + "]";
	}

	@Override
	public int hashCode()
	{
		final int prime = 31;
		int result = 1;
		result = prime * result + ((_so == null) ? 0 : _so.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj)
	{
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AbstractAtgData other = (AbstractAtgData) obj;
		if (_so == null)
		{
			if (other._so != null)
				return false;
		} else if (!_so.equals(other._so))
			return false;
		return true;
	}

}
