/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.dav;

/**
 * Umsetzung der Ausprgungen von <code>att.tsfUrsache</code>.
 * 
 * @author HofmannJ
 * 
 */
public enum E_TSFUrsache
{
	Sonstige(0, "Sonstige"), Verkehrswert(1, "Verkehrswert"), Kalendersteuerung(2,
			"Kalendersteuerung"), Testschaltung(3, "Testschaltung");

	private int _wert = -1;
	private String _bedeutung = null;

	private E_TSFUrsache(int wert, String bedeutung)
	{
		this._wert = wert;
		this._bedeutung = bedeutung;
	}

	@Override
	public String toString()
	{
		return _bedeutung;
	}

	public int getWert()
	{
		return _wert;
	}

	/**
	 * Liefert fr einen int-Wert den entsprechenden Enumerator zur Reprsentation
	 * des Befehls.
	 * 
	 * @param wert
	 * @return
	 */
	public static E_TSFUrsache getBefehl(int wert)
	{
		E_TSFUrsache re = null;

		if (wert >= 0)
		{
			switch (wert)
			{
			case 0:
				re = Sonstige;
				break;
			case 1:
				re = Verkehrswert;
				break;
			case 2:
				re = Kalendersteuerung;
				break;
			case 3:
				re = Testschaltung;
				break;
			}
		}
		
		return re;
	}
}
